<?php
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * ZINA (Zina is not Andromeda) v.0.10.19
 *
 * Zina is a graphical interface to your MP3 collection, a personal
 * jukebox, an MP3 streamer. It can run on its own, embeded into an
 * existing website, or as a Postnuke/PHPNuke module.
 *
 * http://www.pancake.org/zina.html
 * Author: Ryan Lathouwers <ryanlath@pacbell.net>
 * Support: http://sourceforge.net/projects/zina/
 * License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * DEFAULT USER SETTINGS for Zina
 * You can change settings here or put your changes in 'zina.ini.php'
 * so they won't get overridden when upgrading...
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
$z_root_dir = "."; # the root dir of zina script (relative)
$z_mp3_dir = "."; # root dir of the MP3s relative to this file (e.g. ../mp3s or mp3s )

$z_img_dir = "$z_root_dir/_images/"; # dir where zina icons are stored
$z_dir = "$z_root_dir/_zina"; # dir where custom playlists and cache kept
$z_cache = true; # use cache? $z_dir must be writable by webserver user
$z_cache_limit = 7; # days to keep cache.

$z_stream_int = false; # use zina to stream internally
$z_stream_extinf = true; # Add #EXTINF Artist - Title info to playlists (needs $z_stream_int = true;)

# POSTNUKE/PHPNUKE Module support
# See install instructions: http://www.pancake.org/zina_installation.html
$z_postnuke = false; # use as postnuke module?
$z_phpnuke = false; # use as phpnuke module?
$z_pn_users = false; # give access only to logged in p-nuke users

#	Embedding into an existing website (not Post/PHPnuke)
#	See: http://www.pancake.org/zina_installation.html#embed
$z_embed = false;
#$z_page_hdr_title = 'echo "$z_table<tr><td class=z_title><b>$title</b></td></tr></table>";';

$z_width = "725"; # width of zina
$z_main_dir_title = "Artists"; # title of first/main dir
$z_dir_file = "index.txt"; # blurb file for dirs
$z_dir_skip = "_"; # dirs with this prefix are not displayed

# Highlight new files/directories (might incur a performance penalty)
$z_new_highlight = false; # highlight new files and dir
$z_new_time = 14; # within last X days
$z_new_beg = "";
$z_new_end = " <img src=\"$z_img_dir/new.gif\" border=0 alt=\"New\" title=\"title\">";
#$z_new_beg = "<b><i>";
#$z_new_end = "</b></i>";

$z_dir_list = true; # display directory listing (listing on right side)
$z_dir_list_len = 24; # length to truncate long dir names
$z_dir_list_txt = "Albums"; # what to call the directory listing
$z_dir_sec_width = "67"; # % width of section of dir image and text
$z_dir_regex = "/^[0-9][0-9][ ]?-[ ]?/i"; # regex that cleans up dir/title names
#$z_dir_regex = "/^[0-9]{2,4}[ ]?-[ ]?(?=\D)/i";
$z_dir_img_missing = false; # show a missing dir image? Also, see Dynamic Image Resizing below...
$z_dir_img_replace = "${z_img_dir}missing_dir.jpg"; # missing dir image

$z_subdir_images = true; # display subdir images?
$z_subdir_cols = 3; # number of columns for subdir images
$z_subdir_img_cap = false; # display subdir name below subdir image? (uses $z_res_sub_x (below) for width)
$z_subdir_img_missing = false; # show a missing subdir image. Also, see Dynamic Image Resizing below...
$z_subdir_img_replace = "${z_img_dir}missing_subdir.jpg"; # missing subdir image
$z_ext_graphic = "jpg|gif|png|jpeg"; # extensions of graphic files to look for

# For dirs with tons of subdirs (in 0.9.x series, this was default behavior of root dir)
$z_cat_file = "zina_category"; # name of file that makes a directory a "category" e.g. "Artists"
$z_cat_cols = 4; # number of columns on "category" pages
$z_cat_trunc = 25; # length to truncate artist on "category" pages

$z_mp3_info = true; # get filesize, length, kpbs from mp3 file? slower, but cooler
$z_mp3_info_faster = true; # get mp3 info faster / false is more accurate w/ some VBR files
$z_mp3_id3 = false; # use id3v1/2 song titles (if they exist) instead of formatting file names
$z_song_regex = "/^.*[0-9][0-9][ _]?-[ _]?/i"; # if not id3, then this cleans up song filename
$z_song_srch = "_"; # string to search for in song title
$z_song_repl = " "; # string to replace it with
$z_song_blurbs = true; # check for text file named same as mp3 but w/ .txt extentions and display

$z_play = true; # show play icon
$z_play_sel = true; # show option to play "selected"
$z_nav = true; # show navigation
$z_search = true; # show search form
$z_playlists = true; # playlist functionality (other options depend on this)
$z_download = true; # show download icon
$z_amg = true; # show AMG search box

$z_session_pls = true; # allow users to have a "session" playlist
$z_sp_len = 5000; # max length of "session" playlist

$z_random = true; # show the random playlist thing
$z_ran_def = "Songs"; # default random selected ("Albums" or "Songs")
$z_ran_opts = array(1,5,10,25,50,0); # random number options (0 = all)
$z_ran_opts_def = 25; # default random number "selected"

$z_low = false; # look for second (lower quality) mp3 that has the following suffix:
$z_low_suf = ".lofi"; # suffix for second mp3 name[suffix].ext e.g. song.lofi.mp3
$z_low_lookahead = false; # try only if $z_resample=false; & $z_low=true; & not all dirs have lofi files

# Alternative/Related Directories
# If $z_alt_dirs = true will look for a file in the directory named $z_alt_file which
# contains a list of alternative dirs in the format: DIR/DIR (the names of existing directories).
# Add a trailing slash (e.g. DIR/DIR/) for dirs w/o songs (i.e. other Artists)
# It will then show those dirs on the artist page under $z_alt_text
$z_alt_dirs = false;
$z_alt_file = "zina_alt";
$z_alt_text = "Related Albums";

#	Want to have a song listed but that's not there?
#	Set $z_fake = true; and create a file in a songs directory
#	with $z_fake_ext extension, e.g: 04 - Song Number Four.fake
$z_fake = false;
$z_fake_ext = "fake";

$z_apache_auth = false; # Append Apache user:password to playlist urls.
$z_local_path = false; # use local paths when running zina locally
$z_loc_is_adm = false; # if running on local machine is local user automatically admin?
$z_adm_ips = ""; # if remote ip is found in this string, remote user is admin
$z_honor_custom = true; # have random stuff use custom title selections

# Different Languages: Currently: English (en), German (de), Spanish (es),
# Italian (it), Dutch (nl), Traditional Chinese (ch), French (fr),
# Danish (da), Bulgarian (bg), Croatian (hr), Hebrew (il), Basque (eu),
# Russian (ru) [UTF-8), (rukoi) [KOI8-R], (ruwin) [Windows-1251],
# Norwegian (no), Turkish (tr)
$z_lang = "en"; # language (see above)
#$z_charset_over = "UTF-8"; # override language character set

# Media Types
# Default setting: mp3,ogg,wav,wma using .m3u playlists via http protocol
# To enable Real Audio support, set $z_other_media_types = true;
# and uncomment 'ra' line.
$z_other_media_types = false;

$z_media_types = array(
	'mp3' => array('ext' => 'm3u', 'proto' => 'http', 'type' => 'audio/mpeg'),
	'ogg' => array('ext' => 'm3u', 'proto' => 'http', 'type' => 'application/x-ogg'),
	'wav' => array('ext' => 'm3u', 'proto' => 'http', 'type' => 'audio/x-wav'),
	'wma' => array('ext' => 'm3u', 'proto' => 'http', 'type' => 'audio/x-ms-wma'),
	#'ra' => array('ext' => 'ram', 'proto' => 'http', 'type' => 'audio/x-pn-realaudio'),
	#'wma' => array('ext' => 'asx', 'proto' => 'mms', 'type' => 'audio/x-ms-wma'),
	#'ra' => array('ext' => 'ram', 'proto' => 'rtsp', 'type' => 'audio/vnd.rn-realaudio'),
	);
$z_media_pls = array(
	'm3u' => 'audio/mpegurl',
	'ram' => 'audio/x-pn-realaudio',
	'asx' => 'video/x-ms-asf',
	);

#	DYNAMIC IMAGE RESIZING
#	WARNING: This will probably be resource intensive!
#	Needs PHP compiled with GD library: http://us3.php.net/manual/en/ref.image.php
#	Make sure GD is functioning without Zina and know what formats your config supports.
#	NOTE: I cannot support Apache/PHP/GD config questions.
#	$xx_resize_type(s) below must only contain formats supported
#	by _YOUR_ PHP/GD setup.

# Input resize types (supported by YOUR configuration)
$z_res_in_types = "jpg|jpeg|png"; # Zina opts: "jpg|jpeg|gif|tiff|png"

# Output resize type (supported by YOUR configuration)
$z_res_out_type = "jpeg"; # Zina opts: jpeg png or gif
$z_res_dir_qual = $z_res_sub_qual = 75; # jpeg quality (1=worst/100=best)

# Set which images you want to scale below to true, change widths
$z_res_dir_img = false; # directory image (main artist/album)
$z_res_dir_x = 200; # scale width

$z_res_sub_img = false; # subdir images (usually albums)
$z_res_sub_x = 200; # scale width

$z_res_out_x_lmt = true; # only resize if orig_width > new_width

# If you use $z_(sub)dir_img_missing above, the following options
# enables writing the (sub)dir title to the image.
$z_dir_img_txt = false; # write dir title?
$z_dir_img_txt_color = "255,255,255"; # R,G,B dir text color (default: black)
$z_subdir_img_txt = false; # write subdir title?
$z_subdir_img_txt_color = "0,0,0"; # R,G,B dir text color (default: white)
$z_img_txt_wrap = "20"; # wrap long text at this char
$z_img_txt_font = "C:\WINNT\Fonts\arial.ttf"; # Full path to TrueTypeFont
$z_img_txt_font_size = "12"; # font size

#	DOWNLOAD SELECTED FILES as one compressed file
#	Requires an external cmd line compression program like zip or gzip
#		or php zlib module
#	For internal: set $z_cmp_sel = true; & $z_cmp_int = true;
#	For external: set $z_cmp_sel = true; & $z_cmp_int = false; &
#		make sure to look at othr $z_cmp_ settings below
#	NOTE: May put a strain on your server
$z_cmp_sel = false; # enable compression option
$z_cmp_int = false; #enable internal compression via php zlib module
$z_cmp_pgm = "C:\cygwin\bin\zip"; # compression program, might need full path
$z_cmp_ext = "zip"; # compression extention. (e.g. zip, gz, tar.gz)
$z_cmp_set = "-0 -j -"; # compression program options
$z_cmp_mime = "application/zip"; # compress mime type

#	Automatic Down/Re-Sampling
#	WARNING: using this will most like bring your server to its knees.
#	But if you want to use it anyway, you will need an external
#	encoder like LAME <http://www.mp3dev.org/mp3/> which can take input from
#	stdin and output to stdout.
#	'enc' => your external encoder, might need full path e.g. "/usr/bin/lame" "C:\Progra~1\lame.exe"
#	'opts' => your encoder settings, default downsamples to 56kbs 22k
#  'output' => stream output type
#	$z_low must be set to 'true' above
$z_resample = false;

$z_enc_arr = array(
	'mp3' => array('enc' => 'lame', 'opts' => '--mp3input -f -b56 --lowpass 12.0 --resample 22.05 - <', 'output' => 'audio/mpeg'),
	'wav' => array('enc' => 'lame', 'opts' => '-f -b56 --lowpass 12.0 --resample 22.05 - <', 'output' => 'audio/mpeg'),
	#NOT TESTED...lame needs to be compiled with libvorbis (or use other encoder)
	#'ogg' => array( 'enc' => 'lame', 'opts' => '--ogginput --ogg -f -b56 --lowpass 12.0 --resample 22.05 - <', 'output' => 'application/x-ogg'),
	);

## Play on Server (jukebox)
# set $z_pos = true;
# Two examples are given below. Uncomment (or put in zina.ini.php) and
# modify paths/pgms to your liking
# (don't change $tmpfname.m3u onward, unless you know what you are doing)
$z_pos = false;
$z_pos_hack = false; # if you use mpg123 and have problems, try this

#Windows/WinAmp
#You'll most likely need http://www.jukkis.net/bgrun/bgrun.exe
#$z_pos_cmd = 'bgrun.exe C:\Progra~1\Winamp\winamp.exe $tmpfname.m3u >NUL';

#Linux/mpg123 (needs next three lines)
#$z_pos_cmd = '/usr/bin/mpg123 -q --list $tmpfname.m3u 0 1> /dev/null 2>&1 &';
#$z_pos_kill = true;
#$z_pos_kill_cmd = 'killall mpg123';

#For OS/2 and eCS use Z! http://dink.org/z/
#$z_pos_cmd = 'z.exe -p $tmpfname.m3u >NUL';

# TIME BASED FUNCTIONALITY (new in 10.0.17, not fully tested)
#
# Any feature that is set 'true' or 'false' can be optionally set to work
# during certain time periods using 'cron'-like syntax.
# NOTES: will override true/false settings. won't affect admin.
# $z_cron['X'][] = "TIME";
# X = setting with '$z_' stripped off.  e.g. for $z_download, use 'download'
# TIME = "WDAY MON MDAY HH:MM" (where...WDAY=0-6, with 0=Sunday; MON=1-12; MDAY=1-31; HH:MM=0-23:0-59)
# '*' matches all; use comma between multiple values, a hyphen to indicate range
#Example 1: Would show play icon all the time (totally pointless)
#$z_cron['play'][] = "* * * *";
#Example 2: Would show download icon between 10pm and 6am everyday...
#$z_cron['download'][] = "* * * 22:00-6:00";
#Example 3: Would show download icon Monday thru Friday during Jan, Mar, May for the first 15 days between 8am and 5pm)
#$z_cron['download'][] = "1-5 1,3,5 1-15 8:00-17:00";
#Example 4: Would show download icon between Midnight and 6am M-F and all day Sat & Sun
#$z_cron['download'][] = "* * * 0:00-6:00";
#$z_cron['download'][] = "6-0 * * *";

# THESE SHOULD BE CHANGED FROM DEFAULT SETTINGS (or set $z_login = false;)
# BY DEFAULT: username is "admin" & password is "password"
# if you don't know the crypt program, after you login in to Zina, go here:
# index.php?l=5
$z_login = true; # can admin login?
$z_adm = "admin"; # admin user name
$z_adm_pass = "fuNA9szthqt2k"; # crypted admin password
$z_salt = "fu"; # salt for crypted password

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * END DEFAULT USER SETTINGS
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * GLOBAL VARS (not user settings)
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
@include(dirname(__FILE__).'/zina.ini.php');

$z_ver = "0.10.19";
$z_auth = "";
if ($z_apache_auth) {
	if (isset($HTTP_SERVER_VARS['PHP_AUTH_USER'])) {
		$z_auth = $HTTP_SERVER_VARS['PHP_AUTH_USER'].":".$HTTP_SERVER_VARS['PHP_AUTH_PW']."@";
	}
}

require("$z_dir/lang/$z_lang.php");
if ($z_lang != "en") {
	if ($z_main_dir_title == "Artists") { $z_main_dir_title = _ZARTISTS; }
	if ($z_dir_list_txt == "Albums") { $z_dir_list_txt = _ZALBUMS; }
	if ($z_alt_text == "Related Albums") { $z_alt_text = _ZRELATED; }
	if ($z_ran_def == "Songs") { $z_ran_def = _ZSONGS; }
	if ($z_ran_def == "Albums") { $z_ran_def = _ZALBUMS; }
}
if (isset($z_charset_over)) { $z_charset = $z_charset_over; }

$z_self = "${HTTP_SERVER_VARS['PHP_SELF']}?";
$z_dirname = (strlen(dirname($z_self)) == 1) ? "" : dirname($z_self);
$z_duh = (substr($z_mp3_dir, -1, 1) == "/") ? substr($z_mp3_dir, 0, strlen($z_mp3_dir) - 1): $z_mp3_dir;
$z_url_base = "http://$z_auth${HTTP_SERVER_VARS['HTTP_HOST']}$z_dirname/$z_duh";
$z_dir_cache = "$z_dir/_dir_cache.dat";
$z_file_cache = "$z_dir/_file_cache.dat";
$z_row_colors = array('z_row1','z_row2');
$z_table = "<table border=\"0\" cellpadding=\"5\" cellspacing=\"0\" width=\"$z_width\">";
$z_img_tmp = "<img border=\"0\" src=\"${z_img_dir}";
$z_img_add = "${z_img_tmp}add.gif\" alt=\""._ZADDTO.":\" title=\""._ZADDTO.":\">";
$z_img_del = "${z_img_tmp}delete.gif\" alt=\""._ZDELETE."\" title=\""._ZDELETE."\">";
$z_img_down = "${z_img_tmp}download.gif\" alt=\""._ZDOWNLOAD."\" title=\""._ZDOWNLOAD."\">";
$z_img_home = "${z_img_tmp}home.gif\" alt=\""._ZHOME."\" title=\""._ZHOME."\" align=left>";
$z_img_more = "${z_img_tmp}more.gif\" alt=\""._ZMORE."\" title=\""._ZMORE."\">";
$z_img_play = "${z_img_tmp}play.gif\" alt=\""._ZPLAY."\" title=\""._ZPLAY."\">";
$z_img_lofi = "${z_img_tmp}play_lofi.gif\" alt=\""._ZPLAYLOFI."\" title=\""._ZPLAYLOFI."\">";
$z_img_pls = "${z_img_tmp}playlist.gif\" alt=\""._ZPLAYLISTS."\" title=\""._ZPLAYLISTS."\">";
$z_img_login = "${z_img_tmp}login.gif\" alt=\""._ZLOGIN."\" title=\""._ZLOGIN."\" align=\"left\">";
$z_img_ren = "${z_img_tmp}rename.gif\" alt=\""._ZRENAME."\" title=\""._ZRENAME."\">";
$z_home = "<a href=\"$z_self\">$z_img_home</a>";
$z_admin = $z_module = $z_play_local = false;
$z_ext_mus = implode("|",array_keys($z_media_types));
$z_ext_enc = implode("|",array_keys($z_enc_arr));

$z_path = isset($HTTP_GET_VARS["p"]) ? $HTTP_GET_VARS["p"] : null;
$z_songs = isset($HTTP_POST_VARS["mp3s"]) ? $HTTP_POST_VARS["mp3s"] : null;
$z_level = isset($HTTP_GET_VARS["l"]) ? $HTTP_GET_VARS["l"] : null;
$z_m = isset($HTTP_GET_VARS["m"]) ? $HTTP_GET_VARS["m"] : null;
$z_playlist = isset($HTTP_POST_VARS["playlist"]) ? $HTTP_POST_VARS["playlist"] : (isset($HTTP_GET_VARS["pl"]) ? $HTTP_GET_VARS["pl"] : null);
$z_imgsrc = isset($HTTP_GET_VARS["img"]) ? $HTTP_GET_VARS["img"] : null;

#Stoopid magic quotes
if(get_magic_quotes_gpc()) {
	$z_deslash = array('$z_path','$z_songs','$z_playlist', '$z_imgsrc');
	foreach($z_deslash as $z_var) eval("$z_var = is_array($z_var) ? array_map('stripslashes', $z_var) : stripslashes($z_var);");
}

#Stoopid Apache2/Win32
$z_rawutf = false;
if (stristr($HTTP_SERVER_VARS["SERVER_SOFTWARE"], "Apache/2.") &&
	strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
	$z_rawutf = true;
}

if ($z_session_pls) { session_start(); }
if ($z_postnuke || $z_phpnuke) { $z_module = true; }

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Postnuke/PHPnuke support
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
#TODO: better security
if ($z_module && $z_level != "6" && $z_level != "10") {
	#pnuke vars: $admin / $user / $this_name
	if ($z_phpnuke) {
		if (!eregi("modules.php", $HTTP_SERVER_VARS["PHP_SELF"]) ) { die ("You can't access this file directly..."); }
		require_once("mainfile.php");
		if (is_admin($admin)) {
			$z_admin = true;
		} elseif ($z_pn_users) {
			if (!is_user($user)) { Header("Location: modules.php?name=Your_Account"); }
		}
	}

	if ($z_postnuke) {
		if (!defined("LOADED_AS_MODULE")) { die ("You can't access this file directly..."); }
		if ($z_pn_users) { if(!pnUserLoggedIn()) { pnRedirect("user.php"); } }
		if (pnSecAuthAction(0, "Zina::", "::", ACCESS_ADMIN)) { $z_admin = true; }
	}

	$this_name = $GLOBALS['name'];
	$z_self = "${z_self}name=$this_name&op=modload&file=index&";
	$z_home = "<a href=\"$z_self\">$z_img_home</a>";
	$z_login = false;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * MAIN
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
if (strstr($z_path,"..")) { pageError(_NOTALLOWED);}

if (strstr($z_adm_ips, $HTTP_SERVER_VARS["REMOTE_ADDR"])) { $z_admin = true; }

if ($HTTP_SERVER_VARS["SERVER_ADDR"] == $HTTP_SERVER_VARS["REMOTE_ADDR"] ||
	$z_pos) {
	if ($z_local_path || $z_pos) {
		$z_url_base = "${HTTP_SERVER_VARS['DOCUMENT_ROOT']}$z_dirname/$z_mp3_dir";
		$z_play_local = true;
	}
	$z_admin = ($z_admin | $z_loc_is_adm);
}

if ($z_login) {
	# for php4.3.3
	if (!$z_session_pls) { session_start(); }
	if (isset($HTTP_SESSION_VARS['admin'])) {
		if ($HTTP_SESSION_VARS['admin'] == true) { $z_admin = true; }
	}
	if (!$z_admin) { $z_home = "<a href=\"${z_self}l=9\">$z_img_login</a> $z_home"; }
}

if (!$z_admin && isset($z_cron)) { timeCheck($z_cron); }

switch ($z_level) {

	case "3" : # CUSTOM PLAYLISTS
		$z_mode = isset($HTTP_GET_VARS["z"]) ? $HTTP_GET_VARS["z"] : null;

		if ($z_admin || $z_session_pls) {
			switch ($z_mode) {
				Case "1" : # View
					pageViewEditPlaylist ($z_playlist, $z_path);
				break;

				Case "2" : # Add New Playlist
					if (!$z_admin) { $z_playlist = "zina_session_playlist"; }
					if ($z_playlist == "new_zina_list") {
						pageNewPlaylist($z_songs);
					} else {
						writeCustomPlaylist($z_songs, "a", "_zina_$z_playlist.m3u");
						if (empty($z_path)) {
							$z_redir = "l=3&z=1&pl=".rawurlencode($z_playlist);
						} else {
							$z_redir = "p=".getURLencodedPath($z_path);
						}
						header("Location: $z_self$z_redir"); exit;
					}
				break;

				Case "3" : # Add Custom Title
					if ($z_admin) {
						writeCustomPlaylist($z_songs, "w", str_replace("/"," - ",$z_path).".m3u", true);
						header("Location: ${HTTP_SERVER_VARS['HTTP_REFERER']}"); exit;
					}
				break;

				Case "4" : # Update Playlist
					$z_order = isset($HTTP_POST_VARS["order"]) ? $HTTP_POST_VARS["order"] : null;
					if (!$z_admin) { $z_playlist = "zina_session_playlist"; }
					writeCustomPlaylist(getReorderedPlaylist($z_songs, $z_order), "w", "_zina_$z_playlist.m3u");
					pageViewEditPlaylist($z_playlist, $z_path);
				break;

				Case "5" : # Delete Playlist
					if ($z_admin) {
						deleteCustomPlaylist($z_playlist);
						header("Location: ${z_self}l=3&z=1"); exit;
					}
				break;

				Case "6" : # Rename Playlist
					if ($z_admin) {
						$z_playlist_new = isset($HTTP_POST_VARS["playlist_new"]) ? $HTTP_POST_VARS["playlist_new"] : "";
						pageRenamePlaylist($z_playlist, $z_playlist_new);
					}
				break;

				default :
					pageError(_ZNOTVALID);
			}
		} else { # NOT ADMIN
			if ($z_mode == "1") {
				pageViewEditPlaylist ($z_playlist, $z_path);
			} else {
				pageError(_ZNOTVALID);
			}
		}
		break;

	Case "4" : # SEARCH
		pageSearchResults($HTTP_POST_VARS["type"], $HTTP_POST_VARS["search"]);
		break;

	Case "5" : # CRYPTOMATIC
		if ($z_admin) {
			$z_c_txt = isset($HTTP_POST_VARS["text"]) ? $HTTP_POST_VARS["text"] : null;
			$z_c_salt = isset($HTTP_POST_VARS["salt"]) ? $HTTP_POST_VARS["salt"] : null;
			pageCryptomatic($z_c_txt, $z_c_salt);
		}
		break;

	Case "6" : # Return resampled MP3 (see settings)
		#Use: index.php?l=6&p=FILE
		if ($z_resample) { sendResampledMP3($z_path); }
		break;

	Case "7" : # return resized image
		if ($z_res_dir_img || $z_res_sub_img) {
			$z_imgarr = array(0 => 'dir', 1 => 'sub');
			$z_it = isset($HTTP_GET_VARS["it"]) ? $HTTP_GET_VARS["it"] : null;
			#Note: $z_path == text, $z_m == color
			eval('sendImageResized($z_imgsrc, $z_res_'.$z_imgarr[$z_it].'_x, $z_res_'.$z_imgarr[$z_it].'_qual, $z_path, $z_m);');
			exit;
		}
		break;

	Case "8" : # RETURN PLAYLISTS
		$z_num = isset($HTTP_POST_VARS["n"]) ? $HTTP_POST_VARS["n"] : null;
		$z_lofi = isset($HTTP_GET_VARS["lf"]) ? $HTTP_GET_VARS["lf"] : false;
		$z_cus = isset($HTTP_GET_VARS["c"]) ? $HTTP_GET_VARS["c"] : false;
		if (!isset($z_m)) {$z_m = isset($HTTP_POST_VARS["m"]) ? $HTTP_POST_VARS["m"] : null; }

		$z_use_cache = array(0 => '', 1 => 'Cached');

		$z_eval = array(
			'sendTitlePlaylist($z_path, false, $z_lofi);', # 0
			'sendSongPlaylist($z_path);', # 1
			'sendTitlePlaylist($z_path, true, $z_lofi);', # 2
			'sendCustomPlaylist($z_playlist, $z_lofi);', # 3
			'sendRandom'.$z_use_cache[$z_cache].'($z_num,"t",$z_lofi);', # 4
			'sendRandom'.$z_use_cache[$z_cache].'($z_num,"s",$z_lofi);', # 5
			'sendSongPlaylistResampled($z_path);',# 6
			'sendSelectedSongs($z_songs, $z_lofi);',# 7
			'sendSelectedCompressed($z_songs, $z_lofi);', # 8
			'sendSelectedCompressedDir($z_path, $z_cus, $z_lofi);' # 9
		);
		eval($z_eval[$z_m]);
		break;

	Case "9": # LOGIN
		if ($z_login) {
			$z_un = isset($HTTP_POST_VARS["un"]) ? $HTTP_POST_VARS["un"] : null;
			$z_up = isset($HTTP_POST_VARS["up"]) ? $HTTP_POST_VARS["up"] : null;
			$z_e = isset($HTTP_GET_VARS["e"]) ? $HTTP_GET_VARS["e"] : null;

			if (empty($z_up) || !empty($z_e)) {
				pageLogin($z_un, $z_e);
			} else {
				Login($z_un, $z_up);
			}
		}
		break;

	Case "10" : # internal streaming
		if ($z_stream_int) { streamItem($z_path); }
		break;

	default : # MAIN PAGE
		pageMain($z_path);
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * PAGE FUNCTIONS (GUI/display stuff)
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

function pageMain($z_path) {
	global $z_self, $z_subdir_images, $z_table, $z_dir_list, $z_dir_list_txt,
		$z_home, $z_main_dir_title, $z_playlists, $z_dir_file, $z_mp3_dir,
		$z_amg, $z_cat_file, $z_alt_dirs, $z_alt_file, $z_alt_text, $z_nav,
		$z_cmp_sel, $z_img_down, $z_dir_sec_width, $z_resample, $z_img_play,
		$z_low, $z_img_lofi, $z_play, $z_download;

	$path_raw = $text = $image = $title = $play_txt = $down_txt = $c_pls_url = "";
	$images_found = 0;
	$category = $custom_pls = $lofi = false;
	$c_pls_arr = null;

	if (file_exists("$z_mp3_dir/$z_path/$z_cat_file")) {
		$z_subdir_images = false;
		$category = true;
	}
	if (file_exists("$z_mp3_dir/$z_path/$z_dir_file")) {
		$text = nl2br(implode("", file("$z_mp3_dir/$z_path/$z_dir_file")));
	}
	if ($z_alt_dirs) {
		$alt_images = 0;
		$alt_file = "$z_mp3_dir/$z_path/$z_alt_file";
		if (file_exists($alt_file)) {
			$alts = file($alt_file);
		} else {
			$z_alt_dirs = false;
		}
	}

	# NAVIGATION
	$nav = $z_home;

	if (!empty($z_path)) {
		$tmp = explode("/",$z_path);

		$tmp_size = sizeof($tmp);
		for ($i = 0; $i < $tmp_size; $i++) {
			if ($path_raw != "") { $path_raw = "$path_raw/"; }
			$path_raw .= rawurlencode($tmp[$i]);
			$title .= formatTitle($tmp[$i]).": ";
			if ($i != $tmp_size - 1) {
				$nav .= " <a href=\"${z_self}p=$path_raw\">${tmp[$i]}</a> :";
			}
			$dir_current = $tmp[$i];
		}
		$path_raw = empty($path_raw) ? "" : "$path_raw/";
		$title = substr($title, 0, -2);
		if (substr($nav, -1, 1) == ":") $nav = substr($nav,0,-1);
	} else {
		$title = $dir_current = $z_main_dir_title;
	}
	$html_title = formatTitle($dir_current);
	if (!$z_nav) $nav = "&nbsp;";

	$arr = getDir($z_path, $images_found, $category);

	if ($z_low && ($z_resample || $arr['lofi'])) { $lofi = true; }

	# Play Text
	if (!empty($arr['files'])) {
		$url_begin = "<a href=\"${z_self}p=".getURLencodedPath($z_path);
		if ($z_play) {
			$url_play = "$url_begin&l=8&m=0\">";
			$play_txt = "$url_play$z_img_play</a> &nbsp;";
		}
		if ($lofi) { $play_txt .= "$url_begin&l=8&m=0&lf=true\">$z_img_lofi</a> &nbsp; "; }
		if ($z_play) { $play_txt .= "${url_play}"._ZPLAY."</a>"; }
		if ($z_play || $lofi || $z_cmp_sel) { $play_txt .= " <i>$html_title</i><br><br>"; }
		if ($z_download && $z_cmp_sel) { $down_txt = "$url_begin/.lp&l=8&m=9&c=0\">$z_img_down</a> &nbsp;"; }
	}

	# Custom Playlist
	global $z_dir, $z_cache;
	$c_pls = "$z_dir/".str_replace("/"," - ",$z_path).".m3u";

	if ($z_cache && file_exists($c_pls)) {
		$custom_pls = true;
		$c_pls_url = "";
		$c_pls_arr = file($c_pls);
		foreach ($c_pls_arr as $key => $value) { $c_pls_arr[$key] = rtrim($value); }

		if ($z_download && $z_cmp_sel) { $c_pls_url .= "$url_begin/.lp&l=8&m=9&c=1\">$z_img_down</a> &nbsp;"; }
		if ($z_play) { $c_pls_url .= "$url_begin&l=8&m=2\">$z_img_play</a> &nbsp;"; }
		if ($lofi) { $c_pls_url .= "$url_begin&l=8&m=2&lf=true\">$z_img_lofi</a> &nbsp; "; }
		if ($z_play) { $c_pls_url .= "$url_begin&l=8&m=2\">"._ZPLAY." <i>$html_title</i> ("._ZCUSTOM.")</a><br><br>"; }
	}

	# Dir Image
	global $z_dir_img_missing;
	if (!$category && (!empty($arr['image']) || $z_dir_img_missing)) {
		global $z_res_dir_img, $z_res_in_types, $z_dir_img_replace, $z_dir_img_txt, $z_dir_img_txt_color;
		$t = "";
		if (empty($arr['image']) && $z_dir_img_missing) {
			$img_src = $z_dir_img_replace;
			if ($z_dir_img_txt) {
				$t = "&p=".rawurlencode($html_title)."&m=$z_dir_img_txt_color";
			}
		} else {
			$img_src = "$z_mp3_dir/$path_raw${arr['image']}";
		}
		if ($z_res_dir_img && preg_match("/\.($z_res_in_types)$/i", $img_src)) {
			$img_src = "${z_self}l=7&it=0&img=$img_src$t";
		}
		$image = "<img src=\"$img_src\" border=\"0\" class=\"z_artist-image\" align=\"left\">";
	}
	$col_width = $category || !$z_dir_list ? "100%" : "$z_dir_sec_width%";

	htmlHeader($title, $nav, htmlRandom(), htmlSearchForm());
	echo "$z_table<tr><td width=\"$col_width\" valign=\"top\"><p>$image$down_txt$play_txt$c_pls_url$text</p></td>";

	if ($category) {
		echo "</tr></table>";
		if (!empty($arr['subdirs'])) { htmlCategory($arr['subdirs']); }
	} else {
		if (!empty($arr['subdirs']) || $z_alt_dirs) {
			$n1 = $n2 = 0;
			$pls_beg = $pls_end = "";
			if ($z_playlists) {
				$pls_beg = "<form name=dirs method=POST action=\"${z_self}p=$path_raw\">";
			}
			echo "<td valign=\"top\">$pls_beg";
			if ($z_dir_list && !empty($arr['subdirs'])) {
				echo "<p><b>$z_dir_list_txt</b></p>";
				$n1 = htmlDirList($arr['subdirs']);
			}
			if ($z_alt_dirs) {
				global $z_low_lookahead;
				echo "<p><b>$z_alt_text</b></p>";
				foreach($alts as $alt) {
					$alt = rtrim($alt);
					$arr2[$alt]['image'] = getDirImage("$z_mp3_dir/$alt", $alt_images);
					$arr2[$alt]['lofi'] = 1;
					if ($z_low_lookahead && !$category) { $arr2[$alt]['lofi'] = getSubDirLofi("$z_mp3_dir/$alt"); }
				}
				$n2 = htmlDirList($arr2);
			}
			if ($z_playlists) {
				$type = ($n1 + $n2 > 0) ? "l a x p q v" : "l x p q v";
				echo "<br>".htmlPlaylistFormElements('dirs', $title, $type)."</form>";
			}
			if ($z_amg) { echo "<br><br>".htmlAMG($html_title, "AMG"); }
			echo "</td>";
		}
		echo "</tr></table>";
		if ($z_subdir_images) {
			global $z_subdir_img_missing;
			if ($images_found > 0 || ($z_subdir_img_missing && !empty($arr['subdirs']))) { htmlDirImages($arr['subdirs'], $z_dir_list_txt); }
			if ($z_alt_dirs && ($alt_images > 0 || $z_subdir_img_missing)) { htmlDirImages($arr2, $z_alt_text); }
		}
	}

	if (!empty($arr['files'])) { htmlSongs(substr($path_raw,0 , -1), $arr['files'], $custom_pls, $c_pls_arr, $lofi); }

	htmlFooter();
}

function pageSearchResults($type, $term) {
	global $z_home, $z_table, $z_row_colors, $z_self, $z_admin, $z_cache, $z_session_pls, $z_play;

	$i = 0;
	if (!empty($term)) {
		$searchfun = array(
			'a' => '$found = searchDir($term);',
			's' => '$found = searchFiles($term);'
		);
		$typefun = array(
			'a' => array('lp' => '/.lp', 'url' => '', 'ft' => '$ft = formatTitle($part);'),
			's' => array('lp' => '', 'url' => '&l=8&m=1', 'ft' => '$ft = formatSongTitle($part);')
		);
		eval($searchfun[$type]);
	}

	htmlHeader(_ZSEARCHRESULTS,$z_home,htmlRandom(),htmlSearchForm($type,$term));

	if (!empty($found)) {
		echo "<form name=sresults method=POST action=\"${z_self}z=1\">$z_table";
		$num = sizeof($found);
		for($j=0; $j < $num; $j++) {
			$ppath = $slash = $surl = "";
			$dir = rtrim($found[$j]);
			echo "<tr class=$z_row_colors[$i]><td>";

			if (($z_admin && $z_cache) || $z_session_pls) {
				echo "<input type=checkbox name=\"mp3s[]\" value=\"".getURLencodedPath($dir).$typefun[$type]['lp']."\"> &nbsp;";
			}
			$arr = explode("/", $dir);
			$num2 = sizeof($arr);
			for ($m=0; $m < $num2; $m++) {
				$part = $arr[$m];
				if ($ppath != "") { $ppath = "$ppath/"; $slash = " / ";}
				$ppath .= $part;
				if ($m == $num2 - 1) {
					$surl = $typefun[$type]['url'];
					eval($typefun[$type]['ft']);
					if ($type == "a" || $z_play) {
						$ft = "<a href=\"${z_self}p=".getURLEncodedPath($ppath)."$surl\">$ft</a>";
					}
				} else {
					$ft = "<a href=\"${z_self}p=".getURLEncodedPath($ppath)."$surl\">".formatTitle($part)."</a>";
				}
				echo "$slash$ft";
			}
			$i = ++$i % 2;
			echo "</td></tr>";
		}
		echo "</table><br>".htmlPlaylistFormElements('sresults')."</form>";
	} else {
		echo "$z_table<tr><td><h3>"._ZNOTFOUND.": \"$term\"</td></tr></table>";
	}

	htmlFooter();
}

function pageViewEditPlaylist ($playlist, $path) {
	global $z_dir, $z_url_base, $z_row_colors, $z_img_ren,
		$z_img_play, $z_self, $z_home, $z_img_del, $z_img_more, $z_admin, $z_cache,
		$z_session_pls, $HTTP_SESSION_VARS, $z_table, $z_ext_mus, $z_play;

	$filename = "$z_dir/_zina_$playlist.m3u";
	$url_play = "<a href=\"${z_self}l=8&m=3&pl=";

	$sp = false;
	if($z_session_pls && $playlist == "zina_session_playlist") {
		if (isset($HTTP_SESSION_VARS['s_p'])) {
			$songs = explode("\n",$HTTP_SESSION_VARS['s_p']);
			unset($songs[sizeof($songs) - 1]);
			$sp = true;
		}
	}

	if ($sp || file_exists($filename)){ # Edit Playlist
		$searchform = "<form name=viewedit method=POST action=\"${z_self}p=$path\">";
		$searchform .= htmlPlaylistFormElements('viewedit', $playlist, "l x p q v d")."</form>";
		htmlHeader(_ZVIEWEDITPLS, $z_home, $searchform, htmlSearchForm());

		if (!$sp) { $songs = file($filename); }
		$url_play .= urlencode($playlist)."\">";

		if (sizeof($songs) > 0) {
			$i = 0; #color
			$j = 1; #order

			echo "<form method=POST name=form01 action=\"${z_self}l=3&p=$path\">".
				"<input type=hidden name=playlist value=\"$playlist\">".
				"$z_table<tr><td colspan=3>";

			if ($sp) {
				global $z_sp_len;
				$sp_perc = round(strlen($HTTP_SESSION_VARS['s_p']) / $z_sp_len * 100, 1);
				echo "<b>"._ZSESSIONPLS."</b> ($sp_perc% full)";
			} else {
				echo "<b>$playlist "._ZPLAYLIST."</b>";
			}
			echo "<br><br></td></tr>";

			foreach($songs as $song) {
				$slash = $ppath = "";
				$song = rtrim($song);
				$arr = explode("/", $song);
				$num = sizeof($arr);
				echo "<tr class=$z_row_colors[$i]><td align=center nowrap>&nbsp;<input type=checkbox name=\"mp3s[]\" value=\"".getURLencodedPath($song)."\" checked>&nbsp;</td>".
					"<td><input type=text name=order[] value=\"$j\" size=2></td><td width=\"100%\">";
				#TODO: similiar to searchResults
				for ($m=0; $m < $num; $m++) {
					$part = $arr[$m];
					if ($ppath != "") { $ppath = "$ppath/"; $slash = " / ";}
					$ppath .= $part;
					if ($m == $num - 1) {
						if (preg_match("/\.($z_ext_mus)$/i", $song)) {
							$surl = '&l=8&m=1';
							$ft = formatSongTitle($part);
							if ($z_play) {
								$ft = "<a href=\"${z_self}p=".getURLEncodedPath($ppath)."$surl\">$ft</a>";
							}
						} elseif ($part == ".lp") {
							continue;
						}
					} else {
						$ft = "<a href=\"${z_self}p=".getURLEncodedPath($ppath)."\">".formatTitle($part)."</a>";

					}
					echo "$slash$ft";
				}
				echo "&nbsp;</td></tr>";
				$i = ++$i % 2; $j++;
			}

			echo "<tr><td colspan=3>";
			if (($z_admin && $z_cache) || ($z_session_pls && $playlist == "zina_session_playlist")) {
			echo "<input type=submit value=\""._ZUPDATE."\" onClick=\"SubmitForm('form01','&z=4');\">"; }
			echo "</td></tr></table></form>";
		}
	} else { # View Playlists
		htmlHeader(_ZPLAYLISTS, $z_home, htmlRandom(), htmlSearchForm());
		$playlists = getCustomPlaylists();
		if ($z_session_pls) {
			if (empty($playlists)) {
				$playlists[] = "zina_session_playlist";
			} else {
				array_unshift($playlists, "zina_session_playlist");
			}
		}
		if (!empty($playlists)) {
			echo "$z_table<tr><td colspan=3><b>"._ZPLAYLIST."</b></td></tr>";

			$i = 0;
			foreach($playlists as $playlist) {
				$pl = urlencode($playlist);
				if ($z_session_pls && $playlist == "zina_session_playlist") {
					$playlist = _ZSESSIONPLS;
				}
				echo "<tr class=$z_row_colors[$i]><td>";
				if ($z_play) { echo "$url_play$pl\">$z_img_play</a> &nbsp;"; }
				echo "<a href=\"${z_self}l=3&z=1&pl=$pl\">$z_img_more</a> &nbsp;";
				if ($z_admin && $z_cache && $playlist != _ZSESSIONPLS) {
					echo "<a href=\"${z_self}l=3&z=5&pl=$pl\">$z_img_del</a> &nbsp;";
					echo "<a href=\"${z_self}l=3&z=6&pl=$pl\">$z_img_ren</a> &nbsp;";
				}
				echo "<a href=\"${z_self}l=3&z=1&pl=$pl\">$playlist</a></td></tr>";
				$i = ++$i % 2;
			}
			echo "</table>";
		} else {
			echo "$z_table<tr><td align=center>"._ZSORRYNOPLS."</td></tr></table>";
		}
	}
	htmlFooter();
}

function pageNewPlaylist($songs){
	global $z_self, $z_home;

	htmlHeader(_ZNEWPLS,$z_home);

	echo "<form method=post action=\"${z_self}l=3&z=2\">".
			"<table border=0 cellspacing=5>".
			"<tr><td>"._ZPLSNAME.":</td><td><input name=playlist type=text size=25 maxlength=30></td>".
			"<td><input type=submit value=\""._ZSUBMIT."\"></td></tr></table>";

	if (sizeof($songs) != 0) {
		sort($songs);
		foreach ($songs as $song) {
			echo "<input type=hidden name=\"mp3s[]\" value=\"$song\">";
		}
	}
	echo "</form>";
	htmlFooter();
}

function pageRenamePlaylist($old, $new = ""){
	global $z_self, $z_home, $z_table, $z_dir;

	$error = "";
	$new = rtrim($new);

	if (!empty($new)) {
		if (renamePlaylist($old, $new)) {
			header("Location: ${z_self}l=3&z=1"); exit;
		} else { $error = _ZCANTRENAME; }
	}

	htmlHeader(_ZNEWPLS,$z_home);

	echo "<form method=post action=\"${z_self}l=3&z=6\">".
		"$z_table<tr><td><b>$error</b></td></tr>".
		"<tr><td>"._ZRENAME." \"$old\""._ZPLAYLIST.": <input name=playlist_new type=text size=25 maxlength=30 value=\"$new\">".
		"<input type=submit value=\""._ZSUBMIT."\"></td></tr></table>".
		"<input type=hidden name=playlist value=\"$old\"></form>";

	htmlFooter();
}

function pageLogin($un = "", $error = "") {
	global $z_self, $z_home;
	htmlHeader(_ZLOGIN,$z_home);

	echo "<form method=post action=\"${z_self}l=9\"><table border=0 cellpadding=5>".
		"<tr><td colspan=2><h3>$error</h3></td></tr>".
		"<tr><td>"._ZUSERNAME.":</td><td><input type=text name=un value=\"$un\"></td></tr>".
		"<tr><td>"._ZPASSWORD.":</td><td><input type=password name=up></td></tr>".
		"<tr><td>&nbsp;</td><td><input type=submit value=\""._ZLOGIN."\"></td></tr>".
		"</table></form>";

	htmlFooter();
}

function pageCryptomatic($text, $salt) {
	global $z_self, $z_home;

	htmlHeader(_ZCRYPTO, $z_home);

	echo "<form method=post action=\"${z_self}l=5\">".
		"<table border=0><tr><td>"._ZPASSWORD.":</td><td><input type=text name=text value=\"$text\"></td></tr>".
		"<tr><td>"._ZSALT.":</td><td><input type=text name=salt value=\"$salt\"></td></tr>".
		"<tr><td>&nbsp;</td><td><input type=submit value=\""._ZGENERATE."\"></td></tr>".
		"</form>";

	if (!empty($text)) {
		echo "<tr><td>"._ZCRYPT.":</td><td><input type=text value=\"".crypt($text, $salt)."\"></td></tr>";
	}

	echo "</table>";
	htmlFooter();
}

function pageError($error) {
	echo "<h1>Zina "._ZERROR."</h1><p><b>$error</b></p>"; exit;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * HTML functions
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

function htmlHeader($title, $left="&nbsp;", $right="&nbsp;", $center="&nbsp;") {
	global $z_root_dir, $z_module, $z_embed, $z_table, $z_postnuke, $z_page_hdr_title,
		$z_nav, $z_search, $z_random, $z_charset, $z_img_dir;

	$css = "<link rel=\"stylesheet\" href=\"$z_root_dir/zina.css\" type=\"text/css\">";
	$css_common = "<link rel=\"stylesheet\" href=\"$z_root_dir/zina_common.css\" type=\"text/css\">";
	$submit = "<script type=\"text/javascript\" src=\"$z_root_dir/zina.js\"></script>";

	if ($z_module) {
		include("header.php");
		global $bgcolor1, $bgcolor2, $bgcolor4;
		$bgc02 = ($z_postnuke) ? $bgcolor4 : $bgcolor2;
		echo "$css_common$submit<style type=\"text/css\">".
			".z_row1 { background-color:$bgcolor1; }.z_row2 { background-color:$bgc02; }</style>";
		OpenTable();
	} elseif ($z_embed) {
		echo "$css_common$submit";
	} else {
		echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">".
			"<html><head><title>Zina: $title</title>".
			"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=$z_charset\">".
			"<link rel=\"shortcut icon\" href=\"$z_img_dir/zina.ico\">" .
			"$css$css_common$submit</head><body>";
	}

	if (!empty($z_page_hdr_title)) {
		eval ($z_page_hdr_title);
	} else {
		echo "$z_table<tr><td class=z_title><b>$title</b></td></tr></table>";
	}
	if ($z_nav || $z_search || $z_random) {
		echo "$z_table<tr><td valign=\"top\" width=\"34%\" nowrap><small>$left</small></td>".
		"<td align=\"center\" valign=\"top\" width=\"33%\" nowrap>$center</td>".
		"<td align=\"right\" valign=\"top\" width=\"33%\" nowrap>$right</td></tr></table>";
	}
}

function htmlFooter() {
	global $z_width, $z_ver, $z_module, $z_embed, $z_table;

	$link = "<a class=z_foot title=\"Zina\" href=\"http://www.pancake.org/zina.html\">Zina v.$z_ver</a>";
	$footer = "<p style=\"width: $z_width; text-align:center; padding:5px;\">$link</p>";

	if ($z_module) {
		echo $footer;
		CloseTable();
		include("footer.php");
	} elseif ($z_embed) {
		echo $footer;
	} else {
		echo "$z_table<tr><td class=z_footer>$link</td></tr></table>";
		echo "</body></html>";
	}
}

function htmlCategory($dirs) {
	global $z_self, $z_cat_cols, $z_cat_trunc, $z_table, $z_new_highlight, $z_new_beg,
		$z_new_end, $z_new_time;

	$row = 0;
	$items = sizeof($dirs);
	$rows_in_col = ceil($items/$z_cat_cols);
	if ($rows_in_col < $z_cat_cols) { $z_cat_cols = ceil($items/$rows_in_col); }
	$col_width = round(100 / $z_cat_cols);
	$now = time();
	$diff = $z_new_time*60*60*24;

	echo "$z_table<tr>";
	foreach ($dirs as $subdir => $opts) {
		if ($row == 0) { echo "<td class=z_artistcols valign=top nowrap width=\"$col_width%\">"; }
		if ($z_new_highlight && ($now - $opts['mtime'] < $diff)) {
			$new_beg = $z_new_beg;
			$new_end = $z_new_end;
		} else {
			$new_beg = $new_end = "";
		}
		echo "<a class=z_artist href=\"${z_self}p=".rawurlencode($subdir)."\">$new_beg".
			formatTitle(strTruncate(basename($subdir),"...",$z_cat_trunc))."$new_end</a><br>";

		$row = ++$row % $rows_in_col;
		if ($row == 0) { echo "</td>"; }
	}
	echo "</tr></table>";
}

function htmlDirList($subdirs) {
	global $z_self, $z_low, $z_img_play, $z_img_lofi, $z_img_more, $z_admin,
		$z_playlists, $z_session_pls, $z_dir_list_len, $z_download, $z_img_down,
		$z_resample, $z_play, $z_new_highlight, $z_new_beg, $z_new_end, $z_new_time;

	$now = time();
	$diff = $z_new_time*60*60*24;
	$num = 0;

	if ($z_low) { $z_dir_list_len -= 2; }

	foreach ($subdirs as $subdir => $opts) {
		$dir = false;
		$image = $opts['image'];
		$new_beg = $new_end = "";
		if (substr($subdir, -1) == "/") {
			$dir = true;
			$subdir = substr($subdir, 0, -1);
		}

		$path_raw = getURLencodedPath($subdir);

		$href = "<a href=\"${z_self}p=$path_raw";
		if (!$dir) {
			if ($z_download) { echo "$href/.lp&l=8&m=9&c=0\">$z_img_down</a> &nbsp;"; }
			if ($z_play) { echo "$href&l=8&m=0\">$z_img_play</a> &nbsp;"; }
			if ($z_low && ($z_resample || $opts['lofi'])) { echo "$href&l=8&m=0&lf=true\">$z_img_lofi</a> &nbsp;"; }
			if ($z_admin || ($z_playlists && $z_session_pls)) { echo "<input type=checkbox name=mp3s[] value=\"$path_raw/.lp\"> &nbsp;"; }
			$num++;
			if ($z_new_highlight && isset($opts['mtime']) && ($now - $opts['mtime'] < $diff)) {
				$new_beg = $z_new_beg;
				$new_end = $z_new_end;
			}
		}
		echo "$href\">$new_beg".formatTitle(strTruncate(basename($subdir),"...",$z_dir_list_len))."$new_end</a><br>";
	}
	return $num;
}

function htmlDirImages($subdirs, $caption) {
	global $z_res_sub_img, $z_res_in_types, $z_subdir_cols, $z_self, $z_table, $z_mp3_dir,
		$z_subdir_img_cap, $z_subdir_img_missing, $z_subdir_img_replace, $z_subdir_img_txt_color,
		$z_subdir_img_txt, $z_res_sub_x;

	$wt = 0;
	$col_width = round(100 / $z_subdir_cols);
	$align[0] = "left";
	$align[$z_subdir_cols - 1] = "right";
	for($i=1; $i < $z_subdir_cols - 1; $i++) { $align[$i] = "center"; }

	echo "$z_table<tr><td class=z_album_img_hdr colspan=$z_subdir_cols><b>$caption</b></td></tr>";

	foreach($subdirs as $subdir => $opts) {
		if ($wt==0) { echo "<tr>"; }
		if (substr($subdir, -1) == "/") { $subdir = substr($subdir, 0, -1); }
		$path_raw = getURLencodedPath($subdir);
		$title = formatTitle(basename($subdir));
		$image = $opts['image'];

		if (!empty($image) || $z_subdir_img_missing) {
			$t = "";
			if (empty($image)) {
				$image = $z_subdir_img_replace;
				if ($z_subdir_img_txt) {
					$t = "&p=".rawurlencode($title)."&m=$z_subdir_img_txt_color";
				}
			} else {
				$image = "$z_mp3_dir/$path_raw/$image";
			}
			if ($z_res_sub_img && preg_match("/\.($z_res_in_types)$/i", $image)) {
				$image = "${z_self}l=7&it=1&img=$image$t";
			}
			echo "<td width=\"$col_width%\" align=\"${align[$wt]}\" valign=\"top\">".
				"<a href=\"${z_self}p=$path_raw\"><img src=\"$image\" border=0 title=\"$title\">";

			if ($z_subdir_img_cap) {
				echo "<br><div class=z_img_cap style=\"width: $z_res_sub_x;\">$title</div>";
			}
			echo "</a></td>";
		} else { $wt--; }

		if ($wt==$z_subdir_cols) { echo "</tr>"; }
		$wt = ++$wt % $z_subdir_cols;
	}

	if ($wt <> 0 ) {
		for ($i = $wt; $i < $z_subdir_cols; $i++) { echo "<td width=\"$col_width%\">&nbsp;</td>"; }
	}
	echo "</tr></table>";
}

function htmlSongs($path_raw, $songs, $custom_pls = false, $c_pls_arr = null, $lofi = false) {
	global $z_url_base, $z_self, $z_img_play, $z_playlists, $z_table,
		$z_img_lofi, $z_img_down, $z_row_colors, $z_admin, $z_cache,
		$z_mp3_id3, $z_mp3_dir, $z_mp3_info, $z_mp3_info_faster, $z_download,
		$z_resample, $z_ext_enc, $z_low, $z_low_suf, $z_ext_mus, $z_session_pls,
		$z_play_sel, $z_cmp_sel, $z_fake, $z_fake_ext, $z_play, $z_new_highlight, $z_new_beg, $z_new_end, $z_new_time;

	$i = 0;
	$check_boxes = false;
	$now = time();
	$diff = $z_new_time*60*60*24;

	if (($z_admin && $z_cache) || ($z_playlists && $z_session_pls) || $z_play_sel || $z_cmp_sel) {
		$check_boxes = true;
	}

	echo "$z_table<tr><td><b>"._ZSONGS."</b></td></tr></table>".
		"<form name=songs method=POST action=\"${z_self}p=$path_raw\">".
		"$z_table<tr><td><table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"5\">";

	foreach ($songs as $song => $opts) {
		$valign = "";
		$blurb = $opts['blurb'];
		if ($blurb) $valign = " valign=top";
		$song_raw = getURLencodedPath($song);
		$song_title = formatSongTitle(basename($song));

		echo "<tr class=$z_row_colors[$i]><td nowrap $valign>";

		if ($z_fake && isset($opts['fake'])) {
			echo "&nbsp;</td><td width=\"100%\"$valign><span class=z_fake_song_title>".
				preg_replace("/\.($z_fake_ext)$/i","",$song_title).
				"</span><br>$blurb</td><td colspan=4>&nbsp;</td>";
		} else {
			if ($z_mp3_info || $z_mp3_id3) {
				$mp3 = new mp3("$z_mp3_dir/$song", $z_mp3_info, $z_mp3_id3, $z_mp3_info_faster);
			}
			$url_play = "";
			$url_end = "";

			if ($check_boxes) {
				$checked = "";
				if ($custom_pls) {
					if (in_array($song, $c_pls_arr)) { $checked = " checked"; }
				}
				echo "<input type=checkbox name=\"mp3s[]\" value=\"$song_raw\"$checked> &nbsp; ";
			} else { echo "&nbsp;"; }

			if ($z_download) { echo "<a href=\"$z_url_base/$song_raw\">$z_img_down</a> &nbsp;&nbsp; "; }
			if ($z_play) {
				$url_play = "<a href=\"${z_self}l=8&p=$song_raw&m=1\">";
				$url_end = "</a>";
				echo "$url_play$z_img_play</a> &nbsp;";
			}
			if ($z_low) {
				$tmp = "&nbsp;<a href=\"${z_self}l=8&p=";
				if (isset($opts['lofi'])) {
					echo "$tmp".preg_replace("/\.($z_ext_mus)$/i", "$z_low_suf.$1", $song_raw).
						"&m=1\">$z_img_lofi</a> &nbsp;";
				} elseif($z_resample && preg_match("/\.($z_ext_enc)$/i", $song)) {
					echo "$tmp$song_raw&m=6\">$z_img_lofi</a> &nbsp;";
				}
			}
			if ($z_new_highlight && isset($opts['mtime']) && ($now - $opts['mtime'] < $diff)) {
				$new_beg = $z_new_beg;
				$new_end = $z_new_end;
			} else {
				$new_beg = $new_end = "";
			}
			echo "</td><td width=\"100%\"$valign>$url_play$new_beg";
			echo ($z_mp3_id3 && $mp3->tag) ? $mp3->title : $song_title;
			echo "$new_end$url_end<br>$blurb</td>";

			if ($z_mp3_info) {
				$tmp = "<td align=right nowrap$valign>";
				if ($mp3->info == 1) {
					echo "$tmp$mp3->time</td>$tmp$mp3->bitrate kbps</td>$tmp".round($mp3->frequency/1000,1)." kHz</td>";
				} else {
					echo "$tmp&nbsp;</td>$tmp&nbsp</td>$tmp&nbsp;</td>";
				}
				echo "$tmp".sprintf("%.2f", round($mp3->filesize/1000000,2))." Mb</td>";
			} else {
				echo "<td colspan=4>&nbsp;</td>";
			}
		}
		echo "</tr>";
		$i = ++$i % 2;
	}
	echo "</tr><tr class=$z_row_colors[$i]><td colspan=2 nowrap>";

	if ($z_admin && $z_cache) {
		$submit = ($custom_pls) ? _ZUPDATECUSTOM : _ZCREATECUSTOM;
		echo "<input type=submit value=\"$submit \" onClick=\"SubmitForm('songs','&l=3&z=3',false);\">";
	}

	if ($check_boxes) {
		echo "&nbsp; "._ZCHECK.": &nbsp;<a href='javascript:void 0;' onClick=\"CheckBoxes('songs',true);\">"._ZALL."</a> | ".
			"<a href='javascript:void 0;' onClick=\"CheckBoxes('songs',false);\">"._ZNONE."</a>".
			" &nbsp; &nbsp; &nbsp; &nbsp; ";

		if ($z_play_sel || $z_cmp_sel) {
			$url_beg2 = " &nbsp; <a href=\"javascript:SubmitForm('songs',";
			echo _ZSELECTED.": ";
			if ($z_play && $z_play_sel) { echo "$url_beg2'${z_self}l=8&m=7',true);\">$z_img_play</a>"; }
			if ($lofi) { echo "$url_beg2'${z_self}l=8&m=7&lf=true',true);\">$z_img_lofi</a>"; }
			if ($z_download && $z_cmp_sel) { echo "$url_beg2'&l=8&m=8',false);\">$z_img_down</a>"; }
		}
	}

	echo "&nbsp;</td><td colspan=4 align=right nowrap>";
	echo ($z_playlists) ? htmlPlaylistFormElements('songs') : "&nbsp;";
	echo "</td></tr></table></td></tr></table></form>";
}

function htmlPlaylistFormElements($form, $playlist_sel = "", $type = "l a x p q v") {
	global $z_self, $z_img_play, $z_img_more, $z_img_add, $z_img_del,
		$z_img_pls, $z_img_lofi, $z_admin, $z_cache, $z_low,
		$z_session_pls, $z_play;

	$options = explode(" ", $type);
	$playlists = getCustomPlaylists();

	if (!$z_admin && (empty($playlists) && !$z_session_pls)) return "";
	$tmp = "<a href=\"javascript:SubmitForm('$form',";

	$elements = array(
		'd' => "$tmp'&l=3&z=5',false);\">$z_img_del</a>&nbsp;",
		'a' => "$tmp'&l=3&z=2',false);\">$z_img_add</a>&nbsp;",
		'v' => "$tmp'&l=3&z=1',false);\">$z_img_more</a>&nbsp;",
		'p' => "$tmp'&l=8&m=3&lf=0',false);\">$z_img_play</a>&nbsp;",
		'q' => "$tmp'&l=8&m=3&lf=true',false);\">$z_img_lofi</a>&nbsp;",
		'l' => "<a href=\"${z_self}l=3&z=1\">$z_img_pls</a>&nbsp;",
		'x' => '<select class=z_small name="playlist">'
		);

	if (!$z_play) { $elements['p'] = ""; }

	if (!$z_admin || !$z_cache) { $elements["d"] = ""; }
	if ((!$z_admin || !$z_cache) && !$z_session_pls) { $elements["a"] = ""; }
	if (!$z_low) { $elements["q"] = ""; }

	if ($z_admin && strstr($type,"a") && $z_cache) {
		$elements["x"] .= '<option value=new_zina_list> - '._ZNEWPLS.' - </option>';
	}

	if ($z_session_pls) {
		$elements["x"] .= '<option value=zina_session_playlist> - '._ZSESSIONPLS.' - </option>';
	}

	if (!empty($playlists)) {
		foreach($playlists as $playlist) {
			$selected = ($playlist == $playlist_sel) ? " selected" : "";
			$elements["x"] .= "<option value=\"$playlist\"$selected>".strTruncate($playlist,"...",15)."</option>";
		}
	}
	$elements["x"] .= "</select>&nbsp;";
	$html = "";
	foreach($options as $option) {
		$html .= $elements[$option];
	}
	return $html;
}

function htmlSearchForm($type="", $term="") {
	global $z_self, $z_img_more, $z_search;

	if ($z_search) {
		$selected = array("a" => null, "s" => null);
		$selected[$type] = " selected";

		return "<form name=sform method=POST action=\"${z_self}l=4\" class=z_small>".
			"<input name=search type=text size=10 class=z_small value=\"$term\"><select name=type class=z_small>".
			"<option value=a$selected[a]>"._ZART_TIT."<option value=s$selected[s]>"._ZSONG."</select>".
			" <a href='javascript:document.sform.submit();'>$z_img_more</a></form>".
			"<script language=JavaScript>document.sform.search.focus();</script>";
			;
	} else {
		return "&nbsp;";
	}
}

function htmlRandom() {
	global $z_random, $z_play;

	$form = "";

	if ($z_play && $z_random) {
		global $z_self, $z_img_play, $z_cache, $z_low, $z_ran_opts, $z_ran_opts_def, $z_ran_def;
		$r_type = array(4 => _ZALBUMS,5 => _ZSONGS);

		$all = $z_cache ? "<option value=0>"._ZALL : "";
		$low = "";
		if ($z_low) {
			global $z_img_lofi;
			$low = " <a href=\"javascript:SubmitForm('random','${z_self}l=8&lf=true', true);\">$z_img_lofi</a>";
		}
		$form = "<span class=z_small><form class=z_small name=random method=post action=\"${z_self}\">"._ZRANDOM.": ".
			"<select class=z_small name=n>";
		foreach($z_ran_opts as $option) {
			$selected = "";
			if ($option == $z_ran_opts_def) $selected = " selected";
			$form .= "<option value=$option$selected>";
			$form .= ($option != 0) ? $option : _ZALL;
		}
		$form .= "</select><select class=z_small name=m>";
		foreach($r_type as $key => $type) {
			$selected = "";
			if ($type == $z_ran_def) $selected = " selected";
			$form .= "<option value=$key$selected>$type";
		}
		$form .= "</select> <a href=\"javascript:SubmitForm('random','${z_self}l=8',true);\">".
			"$z_img_play</a>$low</form></span>";
	}
	return $form;
}

function htmlAMG($text= '', $target = '_blank') {
	return "<form action=\"http://www.allmusic.com/cg/amg.dll\" method=POST target=\"$target\">".
		"<input type=HIDDEN name=P value=amg>".
		"<input class=z_small type=textfield name=sql size=15 maxlength=30 value=\"$text\">".
		"<select name=opt1 class=z_small><option value=1>"._ZARTISTS."<option value=2>"._ZALBUMS."<option value=3>"._ZSONGS."</select>".
		"<input type=submit class=z_small value=AMG></form>";
}

function formatSongTitle($song) {
	global $z_ext_mus, $z_song_regex, $z_song_srch, $z_song_repl;
	$tmp = preg_replace("/\.($z_ext_mus)$/i","",preg_replace($z_song_regex,"",rtrim($song)));
	return str_replace("$z_song_srch","$z_song_repl",$tmp);
}

function formatTitle($title) {
	global $z_dir_regex;
	return preg_replace($z_dir_regex,"",rtrim($title));
}

function strTruncate($str, $replace, $length) {
	return (strlen($str) > $length) ? substr($str,0,$length).$replace : $str;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * GET functions
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

function getDir($dir, &$images_found, $category) {
	global $z_mp3_dir, $z_ext_graphic, $z_ext_mus, $z_dir_skip, $z_subdir_images,
		$z_low, $z_low_suf, $z_song_blurbs, $z_fake, $z_fake_ext, $z_low_lookahead, $z_new_highlight;

	$fdir = "$z_mp3_dir/$dir";
	$subdirs = $files = $image = $text = null;
	$found = $lofi_found = false;

	$d = dir($fdir);
	if (!empty($dir)) { $dir = "$dir/"; }

	while($entry = $d->read()) {
		if ($entry == "." || $entry == "..") { continue; }
		$path = "$dir$entry";
		$cdir = "$fdir/$entry";
		if (is_dir($cdir) && substr($entry,0,1) != $z_dir_skip) {
			$subdirs[$path]['lofi'] = true;
			if ($z_subdir_images) {
				$subdirs[$path]['image'] = getDirImage($cdir, $images_found);
			} else {
				$subdirs[$path]['image'] = null;
			}
			if ($z_low_lookahead && !$category) { $subdirs[$path]['lofi'] = getSubDirLofi($cdir); }
			if ($z_new_highlight) { $subdirs[$path]['mtime'] = filemtime($cdir); }
		} else {
			if (preg_match("/\.($z_ext_mus)$/i", $entry)) {
				if ($z_low && preg_match("/($z_low_suf)\.($z_ext_mus)$/i", $entry)) {
						$path = preg_replace("/($z_low_suf)\.($z_ext_mus)$/i", ".$2", $path);
						$lofi_found = true;
						$files[$path]['lofi'] = 1;
				} else {
					$song_blurb = null;
					if ($z_song_blurbs) {
						$sbfile = "$fdir/".preg_replace("/\.($z_ext_mus)$/i", ".txt", $entry);
						if (file_exists($sbfile)) { $song_blurb = implode("", file($sbfile)); }
					}
					$files[$path]['blurb'] = $song_blurb;
				}
				if ($z_new_highlight) { $files[$path]['mtime'] = filemtime($cdir); }
			} elseif (preg_match("/\.($z_ext_graphic)$/i", $entry) && !$found) {
				$image = rawurlencode($entry);
				$found = true;
			} elseif ($z_fake && preg_match("/\.($z_fake_ext)$/i", $entry)) {
				$song_blurb = null;
				if ($z_song_blurbs) {
					$sbfile = "$fdir/".preg_replace("/\.($z_fake_ext)$/i", ".txt", $entry);
					if (file_exists($sbfile)) { $song_blurb = implode("", file($sbfile)); }
				}
				$files[$path]['blurb'] = $song_blurb;
				$files[$path]['fake'] = 1;
			}
		}
	}
	$d->close();

	if (!empty($subdirs)) { uksort($subdirs, "strnatcasecmp"); }
	if (!empty($files)) { uksort($files, "strnatcasecmp"); }
	return array('subdirs' => $subdirs, 'files' => $files , 'text' => $text, 'image' => $image, 'lofi' => $lofi_found);
}

function getSubDirLofi($path) {
	global $z_ext_mus, $z_mp3_dir, $z_low_suf;

	$d = dir("$z_mp3_dir/$path");
	$lofi = 0;

	while($entry = $d->read()) {
		if (!is_dir($entry) && preg_match("/($z_low_suf)\.($z_ext_mus)$/i", $entry)) {
			$lofi = 1;
			break;
		}
	}
	$d->close();
	return $lofi;
}

function getDirImage($path, &$images_found) {
	global $z_ext_graphic;

	$cover = null;
	$s = dir("$path");
	while($file = $s->read()) {
		$cover = null;
		if (preg_match("/\.($z_ext_graphic)$/i", $file)) {
			$cover = rawurlencode($file);
			$images_found++;
			break;
		}
	}
	$s->close();

	return $cover;
}

function getTitlePlaylist($path, $custom = false, $low = false) {
	return getPlaylist(getSongs($path, true, $custom, $low), $low);
}

function getSongURL($file) {
	global $z_auth, $z_self, $HTTP_SERVER_VARS, $z_stream_int, $z_url_base;
	if ($z_stream_int) {
		return "http://$z_auth${HTTP_SERVER_VARS['HTTP_HOST']}${z_self}l=10&p=".rawurlencode($file)."\n";
	} else {
		return "$z_url_base/".getURLencodedPath2($file);
	}
}

function getURLencodedPath($z_path) {
	$path_raw = "";
	$tmp = explode("/",$z_path);

	$tmp_size = sizeof($tmp);
	for ($i = 0; $i < $tmp_size; $i++) {
		$path_raw .= rawurlencode($tmp[$i]);
		if ($i != $tmp_size - 1) { $path_raw = "$path_raw/"; }
	}
	return $path_raw;
}

#TODO: WTF apache2 sux ass
function getURLencodedPath2($z_path) {
	$path_raw = "";
	$tmp = explode("/",$z_path);

	$tmp_size = sizeof($tmp);
	for ($i = 0; $i < $tmp_size; $i++) {
		$path_raw .= rawurlencoder($tmp[$i]);
		if ($i != $tmp_size - 1) { $path_raw = "$path_raw/"; }
	}
	return $path_raw;
}

function getSongs($z_path, $sort = true, $custom = false, $low = false) {
	global $z_ext_mus, $z_mp3_dir, $z_low_suf, $z_ext_graphic,
		$z_honor_custom, $z_dir, $z_low;

	$songs = $songs2 = null;
	$dir = "$z_mp3_dir/$z_path";

	if (!is_dir($dir)) { pageError("getSongs: \"$dir\" is not a valid dir."); }

	$d = dir($dir);

	while($entry = $d->read()) {
		if (!is_dir("$entry")) {
			if (preg_match("/\.($z_ext_mus)$/i", $entry)) {
				if ($z_low && preg_match("/($z_low_suf)\.($z_ext_mus)$/i", $entry)) {
					$entry = preg_replace("/($z_low_suf)\.($z_ext_mus)$/i", ".$2", $entry);
					$songs[$entry]['lofi'] = 1;
				} else {
					$songs[$entry][] = null;
				}
			}
		}
	}
	$d->close();

	if (!empty($songs)) {
		$c_pls_file = "$z_dir/".str_replace("/", " - ", $z_path).".m3u";
		if ($custom && $z_honor_custom && file_exists($c_pls_file)) {
			$songs2 = file($c_pls_file);
			foreach ($songs2 as $key => $value) {
				$value = rtrim($value);
				$songs2[$key] = $value;
				if ($low && isset($songs[basename($value)]['lofi'])) {
					$songs2[$key] = preg_replace("/\.($z_ext_mus)$/i", "$z_low_suf.$1", $value);
				}
			}
		} else {
			foreach($songs as $key => $value) {
				if ($low && isset($value['lofi'])) {
					$songs2[] = "$z_path/".preg_replace("/\.($z_ext_mus)$/i", "$z_low_suf.$1", $key);
				} else {
					$songs2[] = "$z_path/$key";
				}
			}
		}
		if ($sort) { natcasesort($songs2); }
	}
	return $songs2;
}

function getPlaylist($songs, $low, $c_pls = false) {
	global $z_stream_extinf, $z_url_base, $z_pos, $z_play_local, $z_honor_custom, $z_mp3_dir;
	$playlist = null;

	#TODO: seems to be some hella redundancy here, dude, not all of it performance reasons
	if (!empty($songs)) {
		if ($z_pos || $z_play_local) {
			foreach($songs as $song) {
				$song = rtrim($song);
				if (preg_match("/\.lp$/i", $song)) {
					$song = preg_replace("/\.lp$/i", "", $song);
					$custom = $z_honor_custom ? getTitlePlaylist($song, true, $low) : null;
					$playlist .= empty($custom) ? getTitlePlaylist($song, false, $low) : $custom;
				} else {
					$playlist .= "$z_url_base/$song\n";
				}
			}
		} else {
			$playlist = ($z_stream_extinf) ? "#EXTM3U\n" : "";
			if ($low) {
				global $z_low_suf, $z_ext_mus, $z_resample, $z_ext_enc;
				if ($c_pls) {
					foreach($songs as $song) {
						$song = rtrim($song);
						if (preg_match("/\.lp$/i", $song)) {
							$song = preg_replace("/\.lp$/i", "", $song);
							$custom = $z_honor_custom ? getTitlePlaylist($song, true, $low) : null;
							$playlist .= empty($custom) ? getTitlePlaylist($song, false, $low) : $custom;
						} elseif (preg_match("/^http:\/\//i", $song)) {
							$playlist .= "$song\n";
						} else {
							$song_lofi = urldecode(preg_replace("/(\.$z_ext_mus)$/i", "$z_low_suf$1", $song));
							$song_dec = urldecode($song);
							$playlist .= ($z_stream_extinf) ? "#EXTINF:-1,".getFileArtistTitle($song_dec)."\n" : "";
							if (file_exists("$z_mp3_dir/$song_lofi")) {
								$playlist .= getSongURL($song_lofi)."\n";
							} elseif($z_resample && preg_match("/\.($z_ext_enc)$/i", $song_dec)) {
								$playlist .= getSongResampledURL($song_dec);
							} else {
								$playlist .= getSongURL($song_dec)."\n";
							}
						}
					}
				} else {
					foreach($songs as $song) {
						$song = rtrim($song);
						$song_dec = urldecode($song);
						if (preg_match("/\.lp$/i", $song)) {
							$custom = $z_honor_custom ? getTitlePlaylist($song, true, $low) : null;
							$playlist .= empty($custom) ? getTitlePlaylist($song, false, $low) : $custom;
						} elseif (preg_match("/($z_low_suf)\.($z_ext_mus)$/i", $song, $ext) || !$z_resample || !preg_match("/\.($z_ext_enc)$/i", $song)) {
							$playlist .= ($z_stream_extinf) ? "#EXTINF:-1,".getFileArtistTitle($song_dec)."\n" : "";
							$playlist .= getSongURL($song_dec)."\n";
						} else {
							$playlist .= ($z_stream_extinf) ? "#EXTINF:-1,".getFileArtistTitle($song_dec)."\n" : "";
							$playlist .= getSongResampledURL($song_dec);
						}
					}
				}
			} else {
				foreach($songs as $song) {
					$song = rtrim($song);
					if (preg_match("/\.lp$/i", $song)) {
						$song = preg_replace("/\.lp$/i", "", $song);
						$custom = $z_honor_custom ? getTitlePlaylist($song, true, $low) : null;
						$playlist .= empty($custom) ? getTitlePlaylist($song, false, $low) : $custom;
					} elseif (preg_match("/^http:\/\//i", $song)) {
						$playlist .= "$song\n";
					} else {
						$song_dec = urldecode($song);
						$playlist .= ($z_stream_extinf) ? "#EXTINF:-1,".getFileArtistTitle($song_dec)."\n" : "";
						$playlist .= getSongURL($song_dec)."\n";
					}
				}
			}
		}
	}
	return $playlist;
}

function getCustomPlaylists() {
	global $z_dir;
	$custom_playlists = null;

	if (file_exists($z_dir)) {
		$d = dir($z_dir);

		while($entry = $d->read()) {
			if (substr($entry,0,6) == "_zina_" && preg_match("/\.m3u$/i", $entry) ) {
				$entry = preg_replace("/^_zina_/i","",$entry);
				$custom_playlists[] = preg_replace("/\.m3u$/i","",$entry);
			}
		}
		$d->close();

		if (!empty($custom_playlists)) { natcasesort($custom_playlists); }
	}
	return $custom_playlists;
}

function getReorderedPlaylist($z_songs, $order) {
	$new = $neworder = null;

	$count = sizeof($z_songs);
	if ($count == 0) { return null; }

	for ($i = 0; $i < $count; $i++){
		if ($order[$i] == 0) continue; # 0 == delete
			$new[$order[$i]][] = $z_songs[$i];
	}
	ksort($new);
	$z_songs = null;

	foreach($new as $neworder) {
		foreach($neworder as $song) { $z_songs[] = $song; }
	}
	return $z_songs;
}

function getDirsWithMusic($path = "") {
	global $z_dir_skip, $z_ext_mus, $z_mp3_dir;
	$subdirs = $slash = "";
	$file = false;
	if (!empty($path)) $slash = "/";

	$d = dir("$z_mp3_dir$slash$path");
	while($entry = $d->read()) {
		if ($entry == "." || $entry == "..") { continue;}
		if (is_dir("$z_mp3_dir$slash$path/$entry") && substr($entry,0,1) != $z_dir_skip) {
			$subdirs .= getDirsWithMusic("$path$slash$entry");
		} elseif (!$file && preg_match("/\.($z_ext_mus)$/i", $entry)) {
			$subdirs .= "$path\n";
			$file = true;
		}
	}
	$d->close();

	return $subdirs;
}

function getSongResampledURL($song) {
	global $z_self, $HTTP_SERVER_VARS, $z_auth;
	return "http://$z_auth${HTTP_SERVER_VARS['HTTP_HOST']}${z_self}p=".rawurlencode($song)."&l=6\n";
}

function getFileArtistTitle($file) {
	global $z_mp3_dir, $z_mp3_id3;
	if ($z_mp3_id3) { $mp3 = new mp3("$z_mp3_dir/$file", false, true, true); }
	if ($z_mp3_id3 && $mp3->tag) {
		return "$mp3->artist - $mp3->title";
	} else {
		$x = explode("/", $file);
		$len = sizeof($x);
		$song = formatSongTitle($x[$len - 1]);
		if ($len > 2) {
			return formatTitle($x[$len - 3])." - $song";
		} elseif (!empty($x[$len-2])) {
			return formatTitle($x[$len - 2])." - $song";
		}
		return $song;
	}
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * SEND functions
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

function sendResponse($content) {
	global $z_embed, $z_pos, $z_other_media_types;

	if ($z_embed) { @ob_end_clean(); }

	if ($z_pos) {
		global $HTTP_SERVER_VARS, $z_pos_cmd, $z_pos_kill, $z_pos_kill_cmd, $z_pos_hack;

		$tmpfname = tempnam ("/tmp", "zina-");
		$handle = fopen($tmpfname, "w");
		fwrite($handle, $content);
		fclose($handle);
		if (file_exists("$tmpfname.m3u")) { unlink("$tmpfname.m3u"); }
		rename($tmpfname, "$tmpfname.m3u");

		if ($z_pos_kill) { exec($z_pos_kill_cmd); }
		eval("\$z_pos_cmd = \"$z_pos_cmd\";");
		if ($z_pos_hack) { session_write_close(); }
		exec($z_pos_cmd);
		#sleep(2);
		#unlink("$tmpfname.m3u");
		header("Location: ${HTTP_SERVER_VARS['HTTP_REFERER']}");
	} else {
		if ($z_other_media_types) {
			$play_ext = null;
			global $z_ext_mus, $z_media_types, $z_media_pls;
			$content = preg_replace("#.*?://(.*\.)($z_ext_mus)(\n|$)#ie", "\$z_media_types['$2'][\"proto\"].\"://\".'$1'.'$2'.'$3'", $content);
			preg_match_all("/\.($z_ext_mus)(\n|$)/i", $content, $ext);
			foreach($ext[1] as $e) { @$play_ext[$e]++; }
			if (sizeof($play_ext) > 1) { arsort($play_ext); }
			$pls_ext = $z_media_types[key($play_ext)]['ext'];
			header("Content-type: ".$z_media_pls[$pls_ext]);
			header("Content-Disposition: inline; filename=playlist.$pls_ext");
		} else {
			header("Content-type: audio/mpegurl");
			header("Content-Disposition: inline; filename=playlist.m3u");
		}
		header("Cache-control: private"); #IE seems to need this.
		echo $content;
	}
	exit;
}

function sendSongPlaylist ($z_path) {
	global $z_url_base, $z_pos, $z_play_local;
	if ($z_pos || $z_play_local) {
		sendResponse("$z_url_base/$z_path\n");
	} else {
		sendResponse(getSongURL($z_path));
	}
}

function sendSongPlaylistResampled ($song) {
	sendResponse(getSongResampledURL($song));
}

function sendTitlePlaylist ($z_path, $custom, $low = false) {
	sendResponse(getTitlePlaylist($z_path, $custom, $low));
}

function sendSelectedSongs($songs, $low = false) {
	sendResponse(getPlaylist($songs, $low, true));
}

function sendCustomPlaylist($pls_name, $low) {
	global $z_dir, $z_session_pls, $HTTP_SESSION_VARS;
	$songs = null;

	if($z_session_pls && $pls_name == "zina_session_playlist") {
		if (isset($HTTP_SESSION_VARS['s_p'])) {
			$songs = explode("\n",$HTTP_SESSION_VARS['s_p']);
			unset($songs[sizeof($songs) - 1]);
		}
	} else {
		if ($pls_name != "new_zina_list") {
			$filename = "$z_dir/_zina_".str_replace("/"," - ",$pls_name).".m3u";
			$songs = file($filename);
		}
	}
	sendResponse(getPlaylist($songs, $low, true));
}

function sendRandom($num, $type = "t", $low = false) {
	$playlist = null;

	set_time_limit(60);
	$array = explode("\n",trim(getDirsWithMusic()));

	if ($type == "s") {
		$dirs = $array;
		$array = null;
		foreach ($dirs as $dir) {
			$array = array_merge($array, getSongs(rtrim($dir), false, false, false));
		}
	}
	$total = sizeof($array);
	if ($num == 0 || $num > $total) { $num = $total; }

	o_shuffle($array);

	if ($type == "t") {
		for($i = 0; $i < $num; $i++) {
			$playlist .= getTitlePlaylist(rtrim($array[$i]), false, $low);
		}
	} else {
		$playlist = getPlaylist(array_slice($array,0,$num), $low);
	}
	sendResponse($playlist);
}

function sendRandomCached($num, $type = "t", $low = false) {
	global $z_dir_cache, $z_file_cache, $z_honor_custom, $z_url_base,
		$z_low_suf, $z_pos, $z_play_local;

	$playlist = null;
	$file = $z_dir_cache;

	writeRandomCache($type, $low);
	if ($type == "s") {
		$file = $z_file_cache;
		if ($low) { $file = preg_replace("/(\.dat)$/i", "$z_low_suf$1", $z_file_cache); }
	}
	$array = file($file);
	$total = sizeof($array);

	if ($num == 0 || $num > $total) { $num = $total; }

	o_shuffle($array);

	if ($type == "t") {
		for($i = 0; $i < $num; $i++) {
			$custom = $z_honor_custom ? getTitlePlaylist(rtrim($array[$i]), true, $low) : null;
			$playlist .= empty($custom) ? getTitlePlaylist(rtrim($array[$i]), false, $low) : $custom;
		}
	} elseif ($type == "s") {
		$playlist = getPlaylist(array_slice($array,0,$num), $low);
	}

	sendResponse($playlist);
}

#TODO: fails with some users setups?
function streamItem ($path) {
	global $z_enc, $z_mp3_dir, $HTTP_SERVER_VARS,
		$z_phpnuke, $z_embed, $z_dirname, $z_ext_mus, $z_media_types;

	$file = "${HTTP_SERVER_VARS['DOCUMENT_ROOT']}$z_dirname/$z_mp3_dir/$path";
	preg_match("/\.($z_ext_mus)$/i", $path, $exts);

	set_time_limit(0);
	$icy = getFileArtistTitle($path);

	# phpnuke uses ob_gzhandler
	if ($z_embed || $z_phpnuke) { while(@ob_end_clean()); }

	$in = fopen($file, "rb");
	header("ICY 200 OK");
	header("icy-name: $icy");
	header("Connection: close");

	header("Content-type: ".$z_media_types[strtolower($exts[1])]['type']);
	header("Content-Disposition: filename=$icy");
	header("Content-Length: ".filesize($file) );

	$headers = @getallheaders();
	if (isset($headers['Range'])) {
		fseek($in, preg_replace('/[^0-9]+/','',$headers['Range']));
	}
	fpassthru($in);
	exit;
}

function sendResampledMP3 ($path) {
	global $z_mp3_dir, $HTTP_SERVER_VARS, $z_phpnuke, $z_embed, $z_dirname,
		$z_ext_enc, $z_enc_arr;

	$file = "\"${HTTP_SERVER_VARS['DOCUMENT_ROOT']}$z_dirname/$z_mp3_dir/$path\"";
	preg_match("/\.($z_ext_enc)$/i", $path, $exts);
	$enc = $z_enc_arr[$exts[1]]['enc'];
	$opts = $z_enc_arr[$exts[1]]['opts'];
	$output = $z_enc_arr[$exts[1]]['output'];
	$icy = getFileArtistTitle($path);

	# phpnuke uses ob_gzhandler
	if ($z_embed || $z_phpnuke) { while(@ob_end_clean()); }

	header("ICY 200 OK");
	header("icy-name: $icy");
	header("Content-type: $output");
	header("Content-Disposition: filename=".basename($path));
	header("Connection: close");
	passthru("$enc $opts $file");
	exit;
}

function sendSelectedCompressedDir($dir, $custom, $low) {
	$dir = preg_replace("/\/\.lp$/i", "", $dir);
	$songs = getSongs($dir, true, $custom, $low);
	sendSelectedCompressed($songs, $low);
}

function sendSelectedCompressed($songs, $lofi = false) {
	global $z_mp3_dir, $z_cmp_pgm, $z_cmp_ext, $z_cmp_set, $z_cmp_mime, $z_cmp_sel, $z_cmp_int;

	#TODO: lowfi, baby
	if ($z_cmp_sel) {
		$files = null;

		if ($z_cmp_int) {
			$archive = new zipfile;

			foreach ($songs as $song) {
				$file = "$z_mp3_dir/".urldecode($song);
				$file_size = filesize($file);
				$fp = fopen($file, "rb");
				$file_data = fread($fp, $file_size);
				fclose($fp);

				$archive->add_file($file_data,$file);
				unset($file_data);
			}
			header("Content-type: application/zip");
			header("Content-Disposition: inline; filename=selectedmusic.zip");
			echo $archive->file();

		} else { # external
			foreach ($songs as $song) {
				$files .= "\"$z_mp3_dir/".urldecode($song)."\" ";
			}
			header("Content-type: $z_cmp_mime");
			header("Content-Disposition: inline; filename=selectedmusic.$z_cmp_ext");
			passthru("$z_cmp_pgm $z_cmp_set $files");
		}
	}
	exit;
}

function sendImageResized($source, $new_x, $quality, $txt = null, $clr_str = "0,0,0") {
	global $z_res_out_type, $z_embed, $z_res_out_x_lmt;
	$types = array(1 => 'gif', 2 => 'jpeg', 3 => 'png', 7 => 'tiff', 8 => 'tiff');

	$info = getimagesize($source);
	$org_x = $info[0];
	$org_y = $info[1];
	$org_type = $types[$info[2]];
	eval('$org_image = imagecreatefrom'.$org_type.'($source);');

	if (!$z_res_out_x_lmt || $org_x > $new_x) {
		$new_y = intval($org_y * $new_x / $org_x);
		$new_image = @imagecreatetruecolor($new_x, $new_y);
		if (!$new_image) { $new_image = imagecreate($new_x, $new_y); }

		if(!@imagecopyresampled($new_image, $org_image, 0, 0, 0, 0, $new_x, $new_y, $org_x, $org_y)) {
			imagecopyresized($new_image, $org_image, 0, 0, 0, 0, $new_x, $new_y, $org_x, $org_y);
		}
	} else {
		$z_res_out_type = $org_type;
		$new_image = $org_image;
		$new_x = $org_x;
		$new_y = $org_y;
	}
	if (!empty($txt)) {
		global $z_img_txt_wrap, $z_img_txt_font, $z_img_txt_font_size;
		$txt = wordwrap($txt, $z_img_txt_wrap, "\r\n");
		$box = imagettfbbox($z_img_txt_font_size, 0, $z_img_txt_font, $txt);
		$tmp = explode(",",$clr_str);
		$color = imagecolorallocate($new_image, $tmp[0], $tmp[1], $tmp[2]);
		$bx = $box[2] - $box[0];
		$by = $box[5] - $box[3];
		$vert = 2 + (substr_count($txt, "\r\n") * .5);
		$txt_x = ($new_x - $bx)/2;
		$txt_y = ($new_y - $by)/$vert;
		imagettftext($new_image, $z_img_txt_font_size, 0, $txt_x, $txt_y, $color, $z_img_txt_font, $txt);
	}

	if ($z_embed) { ob_end_clean(); }
	Header("Content-type: image/$z_res_out_type");
	eval('image'.$z_res_out_type.'($new_image,"",$quality);');

	@imagedestroy($new_image);
	@imagedestroy($org_image);
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * WRITE/UPDATE/DELETE functions
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

function writeRandomCache($type = "t", $low = false) {
	global $z_cache_limit, $z_dir_cache, $z_file_cache, $z_mp3_dir,
		$z_low_suf, $z_honor_custom;

	set_time_limit(60);

	$files = null;
	$cache_file = $z_dir_cache;

	if ($type == "s") {
		writeRandomCache("t");
		$cache_file = $z_file_cache;
		if ($low) { $cache_file = preg_replace("/(\.dat)$/i", "$z_low_suf$1", $cache_file); }
	}

	if (file_exists($cache_file)) {
		$cache_life = ($z_cache_limit * 86400); #days
		$lastmtime = 0;
		$now = time();

		$lastmtime = filemtime($cache_file);
		if ($now - $lastmtime < $cache_life) return false;
	}

	if ($type == "s") {
		$dirs = file($z_dir_cache);
		foreach ($dirs as $dir) {
			$files .= implode("\n",getSongs(rtrim($dir), false, $z_honor_custom, $low))."\n";
		}
	} else {
		$files = getDirsWithMusic();
	}

	$fp = fopen ($cache_file, "w");
	fwrite($fp,$files);
	fclose($fp);

	return true;
}

function writeCustomPlaylist($songs, $type, $filename, $title = false) {
	global $z_dir, $z_session_pls, $HTTP_SESSION_VARS;

	$playlist = null;
	$filename = "$z_dir/$filename";

	if (!empty($songs)) {
		foreach($songs as $song) { $playlist .= urldecode($song)."\n"; }
	}

	if($z_session_pls && strstr($filename,"zina_session_playlist")) {
		global $z_mode, $z_sp_len;
		if ($z_mode == 4) { #update
			$HTTP_SESSION_VARS['s_p'] = $playlist;
		} else {
			if (strlen($HTTP_SESSION_VARS['s_p']) + strlen($playlist) < $z_sp_len) {
				$HTTP_SESSION_VARS['s_p'] .= $playlist;
			}
		}
	} else {
		$fh = fopen ($filename, $type);
		fwrite($fh,$playlist);
		fclose($fh);
	}

	if ($title && empty($songs) && file_exists($filename)) { unlink($filename); }
}

function deleteCustomPlaylist($pls_name) {
	global $z_dir;

	if ($pls_name != "new_zina_list") {
		$filename = "$z_dir/_zina_$pls_name.m3u";
		if (file_exists($filename)) { unlink($filename); }
	}
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * SEARCH functions
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

function searchDir($term) {
	global $z_cache, $z_dir_cache;

	$found = null;

	if ($z_cache && file_exists($z_dir_cache)) {
		$dirs = file($z_dir_cache);
	} else {
		$dirs = explode("\n",trim(getDirsWithMusic()));
	}

	if (!empty($dirs)) {
		foreach ($dirs as $dir) { if (stristr($dir, $term)) { $found[] = $dir; } }
	}
	return $found;
}

function searchFiles($term) {
	global $z_cache, $z_file_cache;

	$found = null;

	if ($z_cache && file_exists($z_file_cache)) {
		$files = file($z_file_cache);
	} else {
		global $z_honor_custom;
		$files[] = null;
		$dirs = explode("\n",trim(getDirsWithMusic()));
		foreach ($dirs as $dir) {
			$files = array_merge($files, getSongs(rtrim($dir), false, $z_honor_custom, false));
		}
	}

	if (!empty($files)) {
		foreach ($files as $file) {
			if (stristr(basename($file), $term)) {
				if (preg_match("#/.*?$term.*?(\n|$)#i",$file)) {
					$found[] = $file;
				}
			}
		}
	}
	return $found;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * MISC functions
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

function Login($un, $up) {
	global $z_self, $z_adm_pass, $z_adm, $HTTP_SESSION_VARS, $z_salt;
	if ($z_adm == $un && $z_adm_pass == crypt($up,$z_salt)) {
		$HTTP_SESSION_VARS['admin'] = true;
		$redirect = "Location: $z_self";
	} else {
		$HTTP_SESSION_VARS['admin'] = false;
		$redirect = "Location: ${z_self}l=9&e=".rawurlencode(_ZBADLOGIN);
	}
	header($redirect);
}

function renamePlaylist($old, $new) {
	global $z_self, $z_dir;

	$new = rtrim($new);
	$filename = "$z_dir/_zina_$new.m3u";

	if ($new == "") { return false; }
	if ($new == $old) { return true; }
	if (file_exists($filename)) { return false; }
	if(!rename("$z_dir/_zina_$old.m3u", $filename)) { return false; }

	return true;
}

function timeCheck($cron) {
	$now = getdate();
	#$now = getdate(mktime ( 8, 45, 0, 12, 29, 2003));
	$n[0] = $now['wday']; # 0-6; 0 = sun
	$n[1] = $now['mon'];  # 1-12
	$n[2] = $now['mday']; # 0-31
	$n[3] = ($now['hours'] * 60) + $now['minutes']; #0-23:0-59

	foreach($cron as $feature=>$crontabs) {
		eval('global $z_'.$feature.';');
		foreach($crontabs as $crontab) {
			$res = cronCheck($crontab, $n);
			eval('$z_'.$feature.'= $res;');
			if ($res) break;
		}
	}
}

#crontab = "WDAY MON MDAY HH:MM";
function cronCheck($crontab, $now) {
	$tab = explode(" ",$crontab);
	$size = sizeof($tab);
	if ($size != 4) die("bad!");

	for($i=0; $i<4; $i++) {
		$cur = $tab[$i];
		$n = $now[$i];
		if($cur[0] == "*") continue;

		if(strpos($cur,",") !== false) { #multi
			$multi = explode(",",$cur);
			if (!in_array($n, $multi)) return false;
		} elseif (strpos($cur,"-") !== false) { #range
			$range = explode("-",$cur);
			if ($i == 3) {
				$hm = explode(":",$range[0]);
				$r0 = ($hm[0] * 60) + $hm[1];
				$hm = explode(":",$range[1]);
				$r1 = ($hm[0] * 60) + $hm[1];
			} else {
				$r0 = $range[0];
				$r1 = $range[1];
			}
			if ($r0 < $r1) {
				if($n < $r0 || $n > $r1) return false;
			} else {
				if($n < $r0 && $n > $r1) return false;
			}
		} else { #single
			if ($n != $cur) return false;
		}
	}
	return true;
}

function o_shuffle(&$array){
	if (!isset($randinit)){
		srand((double) microtime() * 1000000);
		static $randinit = 1;
	}
	$last = count($array);
	while ($last > 0){
		$last--;
		$z_random = rand(0, $last);
		$temp = $array[$z_random];
		$array[$z_random] = $array[$last];
		$array[$last] = $temp;
	}
	return 1;
}

#for Apache2/Win32
function rawurlencoder($x) {
	global $z_rawutf;
	return ($z_rawutf) ? rawurlencode(utf8_encode($x)) : rawurlencode($x);
}

function debug($x, $exit = false, $phpinfo = false) {
	#$t1 = array_sum(explode(' ', microtime()));
	#$t2 = array_sum(explode(' ', microtime()));
	#echo ($t2-$t1)."s<br>";
	echo "<pre>";
	print_r($x);
	echo "</pre>";
	if ($phpinfo) { phpinfo(32); }
	if ($exit) { exit; }
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * MP3/OGG file info and tags
 *
 * hacked pretty heavily from...
 * MP3::Info by Chris Nandor <http://sf.net/projects/mp3-info/>
 * class.id3.php by Sandy McArthur, Jr. <http://Leknor.com/code/>
 * getID3() [ogg stuff] by James Heinrich <http://www.silisoftware.com>
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

class mp3 {
	function mp3($file, $info=false, $tag=false, $faster=true) {
		$this->file = $file;
		$this->tag = 0;
		$this->info = 0;
		$this->faster = $faster;
		#TODO: get fh once???

		if (stristr(substr($file,-3),'mp3')) {
 			if ($info) $this->getMP3Info();
			if ($tag) $this->getID3Tag();
		} elseif (stristr(substr($file,-3),'ogg')) {
			if ($info || $tag) $this->getOgg($info, $tag);
		} else {
			$this->getBadInfo();
		}
	}
	function getID3Tag() {

		$this->tag = 0;
		$v2h = null;

		if (!($fh = fopen($this->file, 'rb'))) { return 0; }

		$v2h = $this->getV2Header($fh);

		if (!empty($v2h) && !($v2h->major_ver < 2)) {
			$hlen = 10; $num = 4;

			if ($v2h->major_ver == 2) { $hlen = 6; $num = 3; }

			$off = 10; #TODO ext_header?
			$size = null;
			$map = array(
				'2' => array('TT2' => 'title','TP1' => 'artist'),
				'3' => array('TIT2' => 'title', 'TPE1' => 'artist')
				);
			$this->title = $this->artist = null;

			while($off < $v2h->tag_size) {
				$arr = $id = null;
				$found = 0;
				fseek($fh, $off);
				$bytes = fread($fh, $hlen);
				if (preg_match("/^([A-Z0-9]{".$num."})/", $bytes, $arr)) {
					$id = $arr[0];
					$size = $hlen;
					$bytes = array_reverse(unpack("C$num",substr($bytes,$num,$num)));
					for ($i=0; $i<($num - 1); $i++) {
						$size += $bytes[$i] * pow(256,$i);
					}
				} else { break; }
				fseek($fh, $off + $hlen);
				$bytes = fread($fh, $size - $hlen);
				if (isset($map[$v2h->major_ver][$id])) {
					$this->$map[$v2h->major_ver][$id] = trim($bytes);
					$this->tag = 1;
					$this->tag_version = "ID3v2.".$v2h->major_ver;
					if (++$found == 2) { break; }
				}
				$off += $size;
			}
		}
		#if v2 not found look for v1
		if (!$this->tag) {
			if (fseek($fh, -128, SEEK_END) == -1) { return 0; }
			$tag = fread($fh, 128);

			if (substr($tag,0,3) == "TAG") {
				if ($tag[125] == Chr(0) and $tag[126] != Chr(0)) {
					$format = 'a3TAG/a30title/a30artist/a30album/a4year/a28comment/x1/C1track/C1genre';
					$this->tag_version = "ID3v1.1";
				} else {
					$format = 'a3TAG/a30title/a30artist/a30album/a4year/a30comment/C1genre';
					$this->tag_version = "ID3v1";
				}
				$id3tag = unpack($format, $tag);
				foreach ($id3tag as $key => $value) {
					$this->$key = trim($value);
				}
				unset($this->TAG);
				$this->tag = 1;
			}
		}
		fclose($fh);
		return $this->tag;
	}

	function getMP3Info() {
		$file = $this->file;

		if (! ($f = fopen($file, 'rb')) ) { return false; }

		$this->filesize = filesize($file);
		$frameoffset = 0;
		$total = 4096;

		if ($frameoffset == 0) {
			if ($v2h = $this->getV2Header($f)) {
				$total += $frameoffset += $v2h->tag_size;
				fseek($f, $frameoffset);
			} else {
				fseek($f, 0);
			}
		}

		if ($this->faster) {
			do {
				while (fread($f,1) != Chr(255)) { // Find the first frame
					if (feof($f)) { return false; }
				}
				fseek($f, ftell($f) - 1); // back up one byte
				$frameoffset = ftell($f);
				$r = fread($f, 4);

				$bits = decbin($this->unpackHeader($r));

				if ($frameoffset > $total) { return $this->getBadInfo(); }
			} while (!$this->isValidMP3Header($bits));
		} else { #more accurate with some VBRs
			$r = fread($f, 4);
			$bits = decbin($this->unpackHeader($r));

			while (!$this->isValidMP3Header($bits)) {
				if ($frameoffset > $total) { return $this->getBadInfo(); }
				fseek($f, ++$frameoffset);
				$r = fread($f, 4);
				$bits = decbin($this->unpackHeader($r));
			}
		}

		#$this->bits = $bits;
		$this->header_found = $frameoffset;
		$this->vbr = 0;
		$vbr = $this->getVBR($f, $bits[12], $bits[24] + $bits[25], $frameoffset);
		fclose($f);

		#TODO: vbr file size

		if ($bits[11] == 0) {
			$mpeg_ver = "2.5";
			$bitrates = array(
				'1' => array(0, 32, 48, 56, 64, 80, 96, 112, 128, 144, 160, 176, 192, 224, 256, 0),
				'2' => array(0, 8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 144, 160, 0),
				'3' => array(0, 8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 144, 160, 0),
				);
		} else if ($bits[12] == 0) {
			$mpeg_ver = "2";
			$bitrates = array(
				'1' => array(0, 32, 48, 56, 64, 80, 96, 112, 128, 144, 160, 176, 192, 224, 256, 0),
				'2' => array(0, 8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 144, 160, 0),
				'3' => array(0, 8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 144, 160, 0),
				);
		} else {
			$mpeg_ver = "1";
			$bitrates = array(
				'1' => array(0, 32, 64, 96, 128, 160, 192, 224, 256, 288, 320, 352, 384, 416, 448, 0),
				'2' => array(0, 32, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256, 320, 384, 0),
				'3' => array(0, 32, 40, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256, 320, 0),
				);
		}

		$layers = array(array(0,3), array(2,1),);
		$layer = $layers[$bits[13]][$bits[14]];
		if ($layer == 0) return $this->getBadInfo();

		$bitrate = 0;
		if ($bits[16] == 1) $bitrate += 8;
		if ($bits[17] == 1) $bitrate += 4;
		if ($bits[18] == 1) $bitrate += 2;
		if ($bits[19] == 1) $bitrate += 1;
		if ($bitrate == 0) return $this->getBadInfo();

		$this->bitrate = $bitrates[$layer][$bitrate];

		$frequency = array(
			'1' => array(
				'0' => array(44100, 48000),
				'1' => array(32000, 0),
				),
			'2' => array(
				'0' => array(22050, 24000),
				'1' => array(16000, 0),
				),
			'2.5' => array(
				'0' => array(11025, 12000),
				'1' => array(8000, 0),
				),
			 );
		$this->frequency = $frequency[$mpeg_ver][$bits[20]][$bits[21]];
		$mfs = $this->frequency / ($bits[12] ? 144000 : 72000);
		if ($mfs == 0) return $this->getBadInfo();
		$frames = (int)($vbr && $vbr['frames'] ? $vbr['frames'] : $this->filesize / $this->bitrate / $mfs);

		if ($vbr) {
			$this->vbr = 1;
			if ($vbr['scale']) $this->vbr_scale = $vbr['scale'];
			$this->bitrate = (int)($this->filesize / $frames * $mfs);
			if (!$this->bitrate) return $this->getBadInfo();
		}

		$s = -1;
		if ($this->bitrate != 0) {
			$s = ((8*($this->filesize))/1000) / $this->bitrate;
		}

		$this->time = sprintf('%.2d:%02d',floor($s/60),floor($s-(floor($s/60)*60)));
		$this->info = 1;
	}

	function getV2Header($fh) {
		fseek($fh, 0);
		$bytes = fread($fh, 3);

		if ($bytes != 'ID3') return false;

		#$bytes = fread($fh, 3);
		#get version
		$bytes = fread($fh, 2);
		$ver = unpack("C2",$bytes);
		$h->major_ver = $ver[1];
		$h->minor_ver = $ver[2];

		#get flags
		$bytes = fread($fh, 1);

		#get ID3v2 tag length from bytes 7-10
		$tag_size = 10;
		$bytes = fread($fh, 4);
		$temp = array_reverse(unpack("C4", $bytes));
		for($i=0; $i<=3; $i++) {
			$tag_size += $temp[$i] * pow(128,$i);
		}
		$h->tag_size = $tag_size;

		return $h;
	}

	function getVBR($fh, $id, $mode, &$offset) {
		$offset += 4;

		if ($id) {
			$offset += $mode == 2 ? 17 : 32;
		} else {
			$offset += $mode == 2 ? 9 : 17;
		}

		$bytes = $this->Seek($fh, $offset);

		if ($bytes != "Xing") return 0;

		$bytes = $this->Seek($fh, $offset);

		$vbr['flags'] = $this->unpackHeader($bytes);

		if ($vbr['flags'] & 1) {
			$bytes = $this->Seek($fh, $offset);
			$vbr['frames'] = $this->unpackHeader($bytes);
		}

		if ($vbr['flags'] & 2) {
			$bytes = $this->Seek($fh, $offset);
			$vbr['bytes'] = $this->unpackHeader($bytes);
		}

		if ($vbr['flags'] & 4) {
			$bytes = $this->Seek($fh, $offset, 100);
		}

		if ($vbr['flags'] & 8) {
			$bytes = $this->Seek($fh, $offset);
			$vbr['scale'] = $this->unpackHeader($bytes);
		} else {
			$vbr['scale'] = -1;
		}

		return $vbr;
	}

	function isValidMP3Header($bits) {
		if (strlen($bits) != 32) return false;
		if (substr_count(substr($bits,0,11),'0') != 0) return false;
		if ($bits[16] + $bits[17] + $bits[18] + $bits[19] == 4) return false;
		return true;
	}

	function getOgg($info, $tag) {
		$fh = fopen($this->file, 'rb');

		// Page 1 - Stream Header
		$h = null;
		if (!$this->getOggHeader($fh, $h)) { return $this->getBadInfo(); }

		if ($info) {
			$this->filesize = filesize($this->file);

			$data = fread($fh, 23);
			$offset = 0;

			$this->frequency = implode('',unpack('V1', substr($data, 5, 4)));
			$bitrate_average = 0;

			if (substr($data, 9, 4) !== chr(0xFF).chr(0xFF).chr(0xFF).chr(0xFF)) {
				$bitrate_max = implode('',unpack('V1', substr($data, 9, 4)));
			}
			if (substr($data, 13, 4) !== chr(0xFF).chr(0xFF).chr(0xFF).chr(0xFF)) {
				$bitrate_nominal = implode('',unpack('V1', substr($data, 13, 4)));
			}
			if (substr($data, 17, 4) !== chr(0xFF).chr(0xFF).chr(0xFF).chr(0xFF)) {
				$bitrate_min = implode('',unpack('V1', substr($data, 17, 4)));
			}
		}

		if ($tag) {
			// Page 2 - Comment Header
			if (!$this->getOggHeader($fh, $h)) { return $this->getBadInfo(); }
			$data = fread($fh, 16384);
			$offset = 0;
			$vendorsize = implode('',unpack('V1', substr($data, $offset, 4)));
			$offset += (4 + $vendorsize);
			$totalcomments = implode('',unpack('V1', substr($data, $offset, 4)));
			$offset += 4;

			for ($i = 0; $i < $totalcomments; $i++) {
				$commentsize = implode('',unpack('V1', substr($data, $offset, 4)));
				$offset += 4;
				$commentstring = substr($data, $offset, $commentsize);
				$offset += $commentsize;
				$comment = explode('=', $commentstring, 2);
				$comment[0] = strtolower($comment[0]);
				$this->$comment[0] = $comment[1];
			}
			$this->tag_version = "ogg";
			$this->tag = 1;
		}

		if ($info) {
			// Last Page - Number of Samples
			fseek($fh, max($this->filesize - 16384, 0), SEEK_SET);
			$LastChunkOfOgg = strrev(fread($fh, 16384));
			if ($LastOggSpostion = strpos($LastChunkOfOgg, 'SggO')) {
				fseek($fh, 0 - ($LastOggSpostion + strlen('SggO')), SEEK_END);
				if (!$this->getOggHeader($fh, $h)) { return $this->getBadInfo(); }
				$samples = $h->pcm;
				$bitrate_average = ($this->filesize * 8) / ($samples / $this->frequency);
			}

			if ($bitrate_average > 0) {
				$this->bitrate = $bitrate_average;
			} else if (isset($bitrate_nominal) && ($bitrate_nominal > 0)) {
				$this->bitrate = $bitrate_nominal;
			} else if (isset($bitrate_min) && isset($bitrate_max)) {
				$this->bitrate = ($bitrate_min + $bitrate_max) / 2;
			}

			$this->bitrate = (int) ($this->bitrate / 1000);
			$s = -1;
			if (isset($this->bitrate)) {
				$s = (float) (($this->filesize * 8) / $this->bitrate / 1000);
			}
			$this->time = sprintf('%.2d:%02d',floor($s/60),floor($s-(floor($s/60)*60)));
			$this->info = 1;
		}
		return true;
	}

	function getOggHeader(&$fh, &$h) {
		$baseoffset = ftell($fh);
		$data = fread($fh, 16384);
		$offset = 0;
		while ((substr($data, $offset++, 4) != 'OggS')) {
			if ($offset >= 10000) { return FALSE; }
		}

		$offset += 5;
		$h->pcm = implode('',unpack('V1', substr($data, $offset)));
		$offset += 20;
		$segments = implode('',unpack('C1', substr($data, $offset)));
		$offset += ($segments + 8);
		fseek($fh, $offset + $baseoffset, SEEK_SET);

		return true;
	}

	function getBadInfo() {
		$this->time = $this->bitrate = $this->frequency = 0;
		$this->filesize = filesize($this->file);
		return false;
	}

	function Seek($fh, &$offset, $n = 4) {
			fseek($fh, $offset);
			$bytes = fread($fh, $n);
			$offset += $n;
			return $bytes;
	}

	function unpackHeader($byte) {
		return implode('', unpack('N', $byte));
	}
}

/*
	Internal compression of files via PHP zlib extension
	This is most likely based on class zipfile by Eric Mueller <www.themepark.com>
*/
class zipfile {
	var $datasec = array();
	var $rootdir = array();
	var $offset	= 0;

	function add_file($data,$name) {
		#$name	= str_replace('\\', '/', $name);
		$name	= basename($name);
		$ctime = getdate();
		$ctime = preg_replace("/(..){1}(..){1}(..){1}(..){1}/","\\x\\4\\x\\3\\x\\2\\x\\1",dechex(($ctime['year']-1980<<25)|($ctime['mon']<<21)|($ctime['mday']<<16)|($ctime['hours']<<11)|($ctime['minutes']<<5)|($ctime['seconds']>>1)));
		eval('$ctime = "'.$ctime.'";');

		$crc = crc32($data);
		$nlength	= strlen($data);
		$zdata = gzcompress($data,0);
		$zdata = substr(substr($zdata,0,strlen($zdata) - 4),2);
		$clength = strlen($zdata);

		$this->datasec[] = "\x50\x4b\x03\x04\x14\x00\x00\x00\x08\x00$ctime".pack('V',$crc).pack('V',$clength).pack('V',$nlength).pack('v',strlen($name)).pack('v',0).$name.$zdata.pack('V',$crc).pack('V',$clength).pack('V',$nlength);
		$this->rootdir[] = "\x50\x4b\x01\x02\x00\x00\x14\x00\x00\x00\x08\x00$ctime".pack('V',$crc).pack('V',$clength).pack('V',$nlength).pack('v',strlen($name)).pack('v',0).pack('v',0).pack('v',0).pack('v',0).pack('V',32).pack('V',$this->offset).$name;
		$this->offset = strlen(implode('',$this->datasec));
	}

	function file() {
		$data	= implode('',$this->datasec);
		$ctrldir	= implode('',$this->rootdir);
		return $data.$ctrldir."\x50\x4b\x05\x06\x00\x00\x00\x00".pack('v',sizeof($this->rootdir)).pack('v',sizeof($this->rootdir)).pack('V',strlen($ctrldir)).pack('V',strlen($data))."\x00\x00";
	}
}
?>
